Program NoName;
uses
	Exec,Intuition,Graphics;

label
	Error;

var
	Screen:	pScreen;

Function CreateScreen: Pointer;
var
	ns: tNewScreen;
begin
	ns.LeftEdge		:=	0;
	ns.TopEdge		:=	0;
	ns.Width		:=	640;
	ns.Height		:=	256;
	ns.Depth		:=	3;
	ns.DetailPen	:=	0;
	ns.BlockPen		:=	1;
	ns.ViewModes	:=	HIRES;
	ns.Type_		:=	CUSTOMSCREEN+SCREENQUIET+BEEPING;
	ns.Font			:=	NIL;
	ns.DefaultTitle	:=	NIL;
	ns.Gadgets		:=	NIL;
	ns.CustomBitMap	:=	NIL;
	CreateScreen := OpenScreen(@ns);
end;

Procedure SetColor(Reg: Byte;  Val: Word);
var
	r,g,b: Word;
begin
	r := (Val shr 8) and $f;
	g := (Val shr 4) and $f;
	b := Val and $f;
	SetRGB4(@Screen^.ViewPort,Reg,r,g,b);
end;

Procedure Palette(c0,c1,c2,c3,c4,c5,c6,c7: Word);
begin
	SetColor(0,c0);  SetColor(1,c1);
	SetColor(2,c2);  SetColor(3,c3);
	SetColor(4,c4);  SetColor(5,c5);
	SetColor(6,c6);  SetColor(7,c7);
end;

Procedure Box(LeftEdge,TopEdge,Width,Height: Word);
begin
	Move_(@Screen^.RastPort,LeftEdge,TopEdge);
	Draw(@Screen^.RastPort,LeftEdge+Width-1,TopEdge);
	Draw(@Screen^.RastPort,LeftEdge+Width-1,TopEdge+Height-1);
	Draw(@Screen^.RastPort,LeftEdge,TopEdge+Height-1);
	Draw(@Screen^.RastPort,LeftEdge,TopEdge);
end;

Procedure Bar3D(LeftEdge,TopEdge,Width,Height: Word;
	c1,c2,c3,t: Byte);
begin
	if ((t and 1) <> 0) then begin
		SetAPen(@Screen^.RastPort,0);
		RectFill(@Screen^.RastPort,LeftEdge+Width-1,TopEdge+4,
			LeftEdge+Width-1+8,TopEdge+Height-1+4);
		RectFill(@Screen^.RastPort,LeftEdge+8,TopEdge+Height-1,
			LeftEdge+Width-1+8,TopEdge+Height-1+4);
		end;
	if ((t and 2) <> 0) then begin
		SetAPen(@Screen^.RastPort,0);
		Box(LeftEdge-1,TopEdge-1,Width+2,Height+2);
		end;
	SetAPen(@Screen^.RastPort,c2);
	RectFill(@Screen^.RastPort,LeftEdge,TopEdge,LeftEdge+Width-1,TopEdge+Height-1);
	SetAPen(@Screen^.RastPort,c1);
	Move_(@Screen^.RastPort,LeftEdge,TopEdge+Height-2);
	Draw(@Screen^.RastPort,LeftEdge,TopEdge);
	Draw(@Screen^.RastPort,LeftEdge+Width-1,TopEdge);
	SetAPen(@Screen^.RastPort,c3);
	Move_(@Screen^.RastPort,LeftEdge,TopEdge+Height-1);
	Draw(@Screen^.RastPort,LeftEdge+Width-1,TopEdge+Height-1);
	Draw(@Screen^.RastPort,LeftEdge+Width-1,TopEdge+1);
	if ((t and 4) <> 0) then begin
		SetAPen(@Screen^.RastPort,c1);
		Move_(@Screen^.RastPort,LeftEdge+1,TopEdge+Height-3);
		Draw(@Screen^.RastPort,LeftEdge+1,TopEdge+1);
		Draw(@Screen^.RastPort,LeftEdge+Width-2,TopEdge+1);
		SetAPen(@Screen^.RastPort,c3);
		Move_(@Screen^.RastPort,LeftEdge+1,TopEdge+Height-2);
		Draw(@Screen^.RastPort,LeftEdge+Width-2,TopEdge+Height-2);
		Draw(@Screen^.RastPort,LeftEdge+Width-2,TopEdge+2);
		end;
end;

begin
	IntuitionBase := pIntuitionBase(OpenLibrary('intuition.library',0));
	GfxBase := pGfxBase(OpenLibrary('graphics.library',0));
	Screen := CreateScreen;
	if	(IntuitionBase = NIL) or
		(GfxBase = NIL) or
		(Screen = NIL)
		then Goto Error;
	Palette($000,$005,$543,$987,$fed,$f00,$0f0,$654);
	SetAPen(@Screen^.RastPort,1);
	RectFill(@Screen^.RastPort,0,0,639,255);
	Bar3D(100,80,300,80,4,3,2,1+2);
	Bar3D(110,140,60,14,4,3,2,2+4);
	Bar3D(330,140,60,14,4,3,2,2+4);
	Delay(2000);
Error:
	if (Screen <> NIL) then CloseScreen(Screen);
	if (GfxBase <> NIL) then CloseLibrary(pLibrary(GfxBase));
	if (IntuitionBase <> NIL) then CloseLibrary(pLibrary(IntuitionBase));
end.
