{$F+}

{ napisal: Slawomir Juralowicz }

{
	- dlugosc identyfikatorow: 20
	- max. dlugosc linii asm: 256
	- max. ilosc pol tablicy: 10
	- max. zaglebienie: 255
	- a7 - sprzetowy wskaznik stosu
	- a6 - wskaznik na ramke dla zmiennych lokalnych
	- tekst traktowany jak dostep do zmiennej przez adres
	- Znakiem '_' rozpoczynaja sie ciagi
	- Znak := musi byc odzielony spacja
	- W uniecie nie sa kopiowane lokalne stale do asemblera
	- W programie glownym, to co po END. idzie do asemblera
	- _Str_ - zastrzerzone dla ciagow
}

{ Type, Var, Const, Str, PrFu }

Program PCACompiler;

uses
	AmigaDOS;

label
	MainLoop,MainLoop2,PFLoop,FindVar,CompileEnd,LoopUses,LinkPFLoop,LoopSkip;

const
	ConfigFN = 'RAM:ConfigPCA';

	gtEOF	=	0;	{ koniec tekstu }
	gtZnak	=	1;	{ pojedynczy znak }
	gtIdent	=	2;	{ identyfikator }
	gtValue	=	3;	{ stala }
	gtSpec	=	4;	{ podwojny znak specjalny }
	gtEtyk	=	5;	{ etykieta }
	gtStr	=	6;	{ tekst }

	IlSpec	=	11;	{ ilosc podwojnych znakow specjalnych }
	IlInstr	=	43;	{ ilosc instrukcji }

	stndByte	=	0;
	stndUByte	=	1;
	stndWord	=	2;
	stndUWord	=	3;
	stndLong	=	4;
	stndULong	=	5;
	stndNew		=	6;	{ typ zlozony: tablica lub rekord }

	defCopy	=	0;	{ kopia innego typu }
	defAry	=	1;	{ tablica }
	defRec	=	2;	{ rekord }
	defPtr	=	3;	{ wskaznik }

	opMem		=	0;	{ zmienna globalna - w pamieci }
	opSts		=	1;	{ zmienna lokalna - na stosie }
	opAdr		=	2;	{ zmienna z przypisanym adresem }
	opStsPtr	=	3;	{ zmienna lokalna jako parametr po VAR }
	opStsPar	=	4;	{ zmienna lokalna jako parametr }
	opUnk		=	5;	{ nieznana }

	MaxAryTab	=	10;	{ maksymalna ilosc pol w tablicy }

	dtConst		=	0;	{ stala }
	dtVar		=	1;	{ zmienna }
	dtFunc		=	2;	{ funkcja }
	dtVarPtr	=	3;	{ adres zmiennej }
	dtPFPtr		=	4;	{ adres procedury, funkcji }
	dtVarSize	=	5;	{ rozmiar zmiennej }
	dtDzial		=	6;	{ dzialanie }
	dtLet		=	7;	{ znak przypisania }
	dtPole		=	8;	{ nazwa pola rekordu }
	dtPtr		=	9;	{ wskaznik }
	dtNOT		=	10;	{ f-kcja NOT }

	wtNone	=	0;
	wtAry	=	1;
	wtFunc	=	2;

	MaxPri	=	8;	{ maksymalny priorytet dzialania }

	siByte	=	0;	{ dlugosc bajtu }
	siWord	=	1;	{ dlugosc slowa }
	siLong	=	2;	{ dlugosc dlugiego slowa }

	ctConst	=	0;	{ wynik jako stala }
	ctReg	=	1;	{ wynik w Dn }
	ctDVar	=	2;	{ wynik jako dostep do zmiennej }

	IfUnknow	=	0;	{ warunek dynamiczny }
	IfAlways	=	1;	{ zawsze spelniony }
	IfNever		=	2;	{ zawsze falsz }

	FileBuf		=	1024;	{ rozmiar bufora pliku }

	{ ** AmigaDOS ** }

	TypeRecSize		=	108;
	VarRecSize		=	64;
	OneRecSize		=	52;
	ConstRecSize	=	34;
	PrFuRecSize		=	106;
	ParamRecSize	=	28;
	StrRecSize		=	286;
	UsedRecSize		=	26;
	InstallRecSize	=	24;

	BreakRecSize	=	8;
	MRecSize		=	32;
	DRecSize		=	24;
	WRecSize		=	14;
	StackRecSize	=	8;
	ONPRecSize		=	10;
	CompRecSize		=	14;

type
	InstallRec = record
		TypePtr: Pointer;
		PrFuPtr: Pointer;
		ConstPtr: Pointer;
		VarPtr: Pointer;
		StrPtr: Pointer;
		UULPtr: Pointer;
		end;

	{ - rekord instrukcji - }
	InstrRec = record
		Name: String[20];	{ nazwa instrukcji }
		INum: Byte;			{ numer instrukcji }
		end;

	{ - rekord opisu typu - 108 }
	TypeRec = record
		Next: Pointer;
		Name: String[20];			{ nazwa typu }
		AParent: String[20];		{ nazwa typu tablicy lub typu kopii }
		Dpth: Byte;					{ glebokosc typu }
		StndTyp: Byte;				{ czy typ standardowy }
		DefTyp:	Byte;				{ charakterystyka niestnd. typu }
		InUnit: Boolean;			{ pochodzi z unit-u. }
		MemSize,MPSize: LongInt;	{ ile zajmuje pamieci, rozmiar pola }
		Pola: Byte;					{ ilosc pol rekordu, tablicy }
		RecList: Pointer;			{ lista opisujaca pola rekordu }
		AryTab: array [1..MaxAryTab] of LongInt;	{ rozmiary pol tablicy }
		Even: Byte;					{ czy wymagane umieszczenie pod parzystym adresem }
		end;

	{ - rekord opisu zmiennej - 64 }
	VarRec = record
		Next: Pointer;
		Name: String[20];	{ nazwa zmiennej }
		TName: String[20];	{ nazwa typu zmiennej }
		Dpth,Cntr: Byte;	{ glebokosc, numer Proc., Func. w ktorej jest ta zmienna }
		VarOp: Byte;		{ zmienna globalna,lokalna,parametr,wskaznik }
		AdrOfs: LongInt;	{ adres zmiennej - jesli podany }
		MSize: LongInt;		{ ile zajmuje zmienna pamieci }
		Even: Byte;			{ czy musi byc od parzystego adresu }
		AsemVar: Boolean;	{ czy dodawac Cntr do nazwy zmiennej }
		InUnit: Boolean;	{ pochodzi z unit-u. }
		end;

	{ - rekord opisu pola rekordu - 52 }
	OneRec = record
		Next: Pointer;
		Offset: LongInt;	{ przesuniecie do tego pola wzgledem poczatku zmiennej }
		Name: String[20];	{ nazwa pola }
		TName: String[20];	{ nazwa typu pola }
		end;

	{ - rekord stalej - 34 }
	ConstRec = record
		Next: Pointer;
		Dpth: Byte;			{ glebokosc }
		Name: String[20];	{ nazwa stalej }
		Value: LongInt;		{ wartosc stalej }
		InUnit: Boolean;	{ pochodzi z unit-u. }
		end;

	{ - rekord procedury lub funkcji - 106 }
	PrFuRec = record
		Next: Pointer;
		Name: String[20];	{ nazwa }
		Dpth,Cntr: Byte;	{ glebokosc, numer kolejny }
		FuStat: Boolean;	{ True-Func, False-Proc }
		AsmStat: Boolean;	{ True-Asembler Proc lub Func }
		PFUsed,PFInUnit: Boolean;	{ czy uzyta, czy w unicie }
		FTName: String[20];	{ nazwa typu funkcji }
		StackPtr: LongInt;	{ rozmiar stosu dla zmiennych lokalnych }
		StackPar: LongInt;	{ rozmiar stosu dla parametrow }
		IlP,IlUsed: Byte;	{ ilosc parametrow, ilosc w UsedPFList }
		PList: Pointer;		{ lista parametrow }
		MemVar: Pointer;	{ lista parametrow dla forward - zmienna pomocnicza }
		UsedPFList: Pointer;	{ lista uzytych w module proc,func }
		Start,Stop: LongInt;	{ wskaznik na poc. i kon. skompilowanej pf }
		UnitName: String[20];
		end;

	{ - rekord uzycia - 26 }
	UsedRec = record
		Next: Pointer;
		Name: String[20];
		end;

	{ - rekord opisu parametru Proc. lub Func. - 28 }
	ParamRec = record
		Next: Pointer;
		TName: String[20];	{ typ parametru }
		PoVar: Boolean;		{ czy zmienna ze zwrotem wartosci }
		end;

	{ - rekord stalej tekstowej - 286 }
	StrRec = record
		Next: Pointer;
		Num: LongInt;
		Txt: String;
		FromUnit: String[20];
		end;

	{ - rekord skladnika listy struktur z procedury GET - }
	MRec = record
		Next: Pointer;
		Name: String[20];	{ nazwa }
		Typ: Byte;			{ gtXX }
		Value: LongInt;		{ wartosc, jesli stala }
		end;

	{ - rekord skladnika po rozpoznaniu zmiennej, f-kcji, stalej, dzialania - }
	DRec = record
		Next: Pointer;
		Poziom,Typ: Byte;	{ zagniezdzenie, dtXX }
		Dzial: Byte;		{ numer dzialania }
		Pri: LongInt;		{ priorytet dzialania }
		Start: Pointer;		{ poczatek w MList }
		Ilosc: Byte;		{ ilosc skladnikow MRec na zmienna }
		Value: LongInt;		{ wartosc dla stalej }
		ValZnak: Boolean;
		PtrCnt: Byte;
		end;

	WRec = record
		Next: Pointer;
		IlNaw,typ: Byte;
		IlSklad: Byte;
		DPtr: Pointer;
		Stat: Boolean;
		end;

	{ - rekord skladnika ONP. - }
	ONPRec = record
		Next: Pointer;
		Sklad: Pointer;
		Oper: Boolean;
		end;

	StackRec = record
		Next: Pointer;
		Sklad: Pointer;
		end;

	CompRec = record
		Next: Pointer;
		ctTyp,ctVTyp: Byte;
		ValNum: LongInt;
		DPtr: Pointer;
		end;

	BreakType = record
		Next: Pointer;
		Numer: LongInt;
		end;

{
	PFCounter - licznik kolejnej Proc. lub Func. Jesli asembler ma mozliwosc
		kompilacji lokalnej, to pominac go przy nazwach zmiennych i ustalac
		glebokosc kompilacji.

	JumpCnt - licznik skoku. Jesli asembler ma mozliwosc kompilacji lokalnej
		to zerowac go dla kazdej glebokosci.

	StringCnt - licznik uzycia tekstu.
}

var
	UnitStat: Boolean;	{ czy program jest unitem }
	UnitFlush: Boolean;	{ wyprowadzenie danych globalnych }
	UsesUnitList,UFUList: Pointer;

	opOpt: Boolean;	{ czy Bcc.s }
	opLng: Boolean; { czy bez (pc), skoki jmp,jsr }
	opClrD0: Boolean;	{ czy przed wyjsciem czyscic D0 }
	MainFile: Boolean;	{ czy kompilowany jest glowny plik }
	opInst: Boolean;

	InclFN,SrcFN,DstFN,UnitFN,UnitDir,txtTmp: String[80];

	OutFileCnt: LongInt;
	InFile,OutFile: LongInt;
	PFCounter,JumpCnt,StringCnt,RecMemSize,FS,FCnt,Value: LongInt;
	SpecDzial,BackV,GVar,Depth: Byte;
	BackS: Boolean;
	Ident,ErrT: String[20];
	AryWTab: array [1..10] of LongInt;
	SpecTab: array [1..IlSpec] of String[2];
	InstrTab: array [1..IlInstr] of InstrRec;
	PrFuList,TypeList,VarList,ConstList,StrList,BreakList: Pointer;
	AsemStat,FirstPF,HlpB: Boolean;
	ParamVar: ^ParamRec;
	HTxt,HStr: String;
	LineCnt: LongInt;
	DRMin,DRMax,ARMin,ARMax: Byte;
	DRTab: array [0..7,0..1] of Boolean;
	ARTab: array [0..7,0..1] of Boolean;
	INr,MINr: Byte;
	TypeVar: TypeRec;
	VarVar: VarRec;
	Ofs,TSize: LongInt;
	OV: ^OneRec;
	OVL: Pointer;
	PrFuVar: PrFuRec;
	PFPtr,ActualPF,MemPF: ^PrFuRec;
	Hlp: String[20];
	UsedVar: ^UsedRec;
	PFVar: PrFuRec;

	MemVL: Pointer;
	NoFrwd,PFFrwd: Boolean;
	VVar: ^VarRec;

	Bufor: array [1..FileBuf] of Byte;
	FileCnt: Word;
	OutBuf: array [1..FileBuf] of Byte;
	OutFCnt: Word;

	{ ** AmigaDos ** }

	UnitFile,UnitErr: LongInt;

	MemoryList,MMList,MML: Pointer;
	InstV1,InstV2: ^InstallRec;
	CheckMem: Boolean;

{****************************************************************************}

Procedure Loke(Ptr: Pointer);
begin
	ASM
		move.l	8(a6),0
	END;
end;

{****************************************************************************}

Function Leek: Pointer;
begin
	ASM
		move.l	0,8(a6)
	END;
end;

{****************************************************************************}

Function New(Size: LongInt): Pointer;
label
	New0;
begin
	ASM
		move.l	8(a6),d0
		add.l	#12,d0
		moveq	#0,d1
		movem.l	d0/a6,-(sp)
		move.l	4,a6
		jsr		-198(a6)
		movem.l	(sp)+,d1/a6
		clr.l	$c(a6)
		tst.l	d0
		beq		New0
		move.l	d0,a0
		add.l	#12,d0
		move.l	d0,$c(a6)
		move.l	MemoryList,(a0)
		move.l	d0,4(a0)
		move.l	d1,8(a0)
		move.l	a0,MemoryList
New0:
	END;
end;

{****************************************************************************}

Procedure Dispose(Ptr: Pointer);
label
	Disp0,Disp00,Disp1,Disp2;
begin
	ASM
		move.l	8(a6),d0
		lea		MemoryList,a0
Disp2:
		move.l	(a0),a1
		cmpa.l	#0,a1
		beq		Disp0
		cmp.l	4(a1),d0
		beq		Disp1
		movea.l	a1,a0
		bra		Disp2
Disp1:
		move.l	(a1),(a0)
		move.l	8(a1),d0
		move.l	a6,-(sp)
		move.l	4,a6
		jsr		-210(a6)
		move.l	(sp)+,a6
Disp0:
	END;
end;

{****************************************************************************}

Procedure FreeAll;
label
	FrAl0,FrAl1;
begin
	ASM
		lea		MemoryList,a0
FrAl1:
		move.l	(a0),a1
		cmpa.l	#0,a1
		beq		FrAl0
		move.l	(a1),(a0)
		move.l	8(a1),d0
		movem.l	a0/a6,-(sp)
		move.l	4,a6
		jsr		-210(a6)
		movem.l	(sp)+,a0/a6
		bra		FrAl1
FrAl0:
	END;
end;

{****************************************************************************}

Procedure WriteTxt(b: byte);
begin
	UnitErr := Write_(UnitFile,@b,1);
end;

{****************************************************************************}

Procedure FlushOutBuf;
var
	i: Word;
begin
	if (OutFCnt = 0) then Exit;
	UnitErr := Write_(OutFile,@OutBuf,OutFCnt);
	OutFCnt := 0;
end;

{****************************************************************************}

Procedure PutChar(C: Byte);
begin
	if (OutFCnt = FileBuf) then FlushOutBuf;
	Inc(OutFCnt);
	OutBuf[OutFCnt] := C;
end;

{****************************************************************************}

Procedure CloseOut;
begin
	FlushOutBuf;
	Close_(OutFile);
end;

{****************************************************************************}
{ Wyslanie tekstu do pliku. }

Procedure Put(T: String);
var
	i,j: Byte;
begin
	j := Length(T);
	Inc(OutFileCnt,j);
	if (j <> 0) then
		for i := 1 to j do
			PutChar(Ord(T[i]));
end;

{****************************************************************************}
{ Wyslanie tekstu ze znakiem CR. }

Procedure PutL(T: String);
var
	i,j: Byte;
begin
	j := Length(T);
	Inc(OutFileCnt,j+1);
	if (j <> 0) then
		for i := 1 to j do
			PutChar(Ord(T[i]));
	PutChar(10);
end;

{****************************************************************************}

Procedure AddPFCall(PFV: PrFuRec);
label
	Loop1;

	Procedure CopyUsed;
	var
		UV: ^UsedRec;
	begin
		UV := PFV.UsedPFList;
		while (UV <> NIL) do begin
			UsedVar := New(UsedRecSize);
			UsedVar^.Name := UV^.Name;
			UsedVar^.Next := ActualPF^.UsedPFList;
			ActualPF^.UsedPFList := UsedVar;
			Inc(ActualPF^.IlUsed);
			UV := UV^.Next;
			end;
	end;

begin
	UsedVar := ActualPF^.UsedPFList;
Loop1:
	if (UsedVar = NIL) then begin
		CopyUsed;
		UsedVar := New(UsedRecSize);
		UsedVar^.Name := PFV.Name;
		UsedVar^.Next := ActualPF^.UsedPFList;
		ActualPF^.UsedPFList := UsedVar;
		Inc(ActualPF^.IlUsed);
		Exit;
		end;
	if (UsedVar^.Name = PFV.Name) then Exit;
	UsedVar := UsedVar^.Next;
	Goto Loop1;
end;

{****************************************************************************}
{ Ustawienie bitu. }

Procedure BSet(Num: LongInt; var Val: LongInt);
begin
	Val := Val or (1 shl Num);
end;

{****************************************************************************}
{ Testowanie bitu. }

Function BTst(Num: LongInt; Val: LongInt): Boolean;
begin
	BTst := ((1 shl Num) and Val) <> 0;
end;

{****************************************************************************}
{ Jesli wartosc nieparzysta, to zwiekszenie w gore o jeden. }

Procedure EEven(var D: LongInt);
begin
	if ((D AND 1) = 1) then Inc(D);
end;

{****************************************************************************}
{ Wszystkie litery w ciagu na duze. }

Procedure UpStr(var T: String);
label
	Skok1,Skok2;
begin
		ASM
		movea.l	8(a6),a0
		move.b	(a0)+,d0
Skok1:
		subq.b	#1,d0
		bmi		Skok2
		move.b	(a0)+,d1
		cmp.b	#97,d1
		bcs		Skok1
		cmp.b	#122,d1
		bhi		Skok1
		sub.b	#32,-1(a0)
		bra		Skok1
Skok2:
		END;
end;

{****************************************************************************}
{ Czy znak jest litera. }

Function Lit(C: Char): Boolean;
label
	Lit1,Lit2;
begin
	ASM
		sf		10(a6)
		move.b	9(a6),d0
		cmp.b	#95,d0
		beq		Lit1
		cmp.b	#65,d0
		bcs		Lit2
		cmp.b	#91,d0
		bcs		Lit1
		cmp.b	#97,d0
		bcs		Lit2
		cmp.b	#122,d0
		bhi		Lit2
Lit1:
		st		10(a6)
Lit2:
	END;
end;

{****************************************************************************}
{ Czy znak jest cyfra. }

Function Cyf(C: Char): Boolean;
label
	Cyf1;
begin
	ASM
		sf		10(a6)
		cmp.b	#48,9(a6)
		bcs		Cyf1
		cmp.b	#57,9(a6)
		bhi		Cyf1
		st		10(a6)
Cyf1:
	END;
end;

{****************************************************************************}
{ Czy znak jest cyfra szesnastkowa. }

Function HCyf(C: Char): Boolean;
label
	HCyf1,HCyf2;
begin
	ASM
		sf		10(a6)
		move.b	9(a6),d0
		cmp.b	#48,d0
		bcs		HCyf2
		cmp.b	#58,d0
		bcs		HCyf1
		cmp.b	#65,d0
		bcs		HCyf2
		cmp.b	#71,d0
		bcs		HCyf1
		cmp.b	#97,d0
		bcs		HCyf2
		cmp.b	#102,d0
		bhi		HCyf2
HCyf1:
		st		10(a6)
HCyf2:
	END;
end;

{****************************************************************************}
{ Czy znak jest cyfra binarna. }

Function BCyf(C: Char): Boolean;
label
	BCyf1,BCyf2;
begin
	ASM
		sf		10(a6)
		cmp.b	#48,9(a6)
		beq		BCyf1
		cmp.b	#49,9(a6)
		bne		BCyf2
BCyf1:
		st		10(a6)
BCyf2:
	END;
end;

{****************************************************************************}
{ Czy znak jest litera lub cyfra. }

Function LitCyf(C: Char): Boolean;
begin
	LitCyf := Lit(C) or Cyf(C);
end;

{****************************************************************************}

Procedure Err(Num: Byte);
FORWARD;

{****************************************************************************}
{ Wyslanie wzglednego skoku. }

Procedure PutBRA(T: String);
begin
	if opLng then begin
		Put(#9#9'jmp'#9);
		PutL(T);
		Exit;
		end;
	if opOpt then begin
		Put(#9#9'bra.s'#9);
		PutL(T);
		end
	else begin
		Put(#9#9'bra'#9);
		PutL(T);
		end;
end;

{****************************************************************************}
{ Wyslanie wzglednego skoku do podprogramu. }

Procedure PutBSR(T: String);
begin
	if opLng then begin
		Put(#9#9'jsr'#9);
		PutL(T);
		Exit;
		end;
	if opOpt then begin
		Put(#9#9'bsr.s'#9);
		PutL(T);
		end
	else begin
		Put(#9#9'bsr'#9);
		PutL(T);
		end;
end;

Procedure PutBNE(N: LongInt);
begin
	Str(N,HTxt);
	if opOpt then begin
		Put(#9#9'bne.s'#9'_');
		if UnitStat then begin
			Put(UnitFN);
			Put('_');
			end;
		PutL(HTxt);
		end
	else begin
		Put(#9#9'bne'#9'_');
		if UnitStat then begin
			Put(UnitFN);
			Put('_');
			end;
		PutL(HTxt);
		end;
end;

Procedure PutBRA2(N: LongInt);
begin
	Str(N,HTxt);
	if opOpt then begin
		Put(#9#9'bra.s'#9'_');
		if UnitStat then begin
			Put(UnitFN);
			Put('_');
			end;
		PutL(HTxt);
		end
	else begin
		Put(#9#9'bra'#9'_');
		if UnitStat then begin
			Put(UnitFN);
			Put('_');
			end;
		PutL(HTxt);
		end;
end;

Procedure PutBEQ(N: LongInt);
begin
	Str(N,HTxt);
	if opOpt then begin
		Put(#9#9'beq.s'#9'_');
		if UnitStat then begin
			Put(UnitFN);
			Put('_');
			end;
		PutL(HTxt);
		end
	else begin
		Put(#9#9'beq'#9'_');
		if UnitStat then begin
			Put(UnitFN);
			Put('_');
			end;
		PutL(HTxt);
		end;
end;


{****************************************************************************}
{ Pobranie struktury typu o podanej nazwie. Jesli Fine=True i typ bedzie ty-
pem skopiowanym, to pobranie typu nadrzednego. }

Procedure GetType(Nm: String; Fine: Boolean; var V: TypeRec);
label
	Retry;
var
	TypeVar: ^TypeRec;
begin
Retry:
	TypeVar := TypeList;
	while (TypeVar <> NIL) do begin
		if (TypeVar^.Name = Nm) then begin
			V := TypeVar^;
			if Not(Fine) then Exit;
			if (V.stndTyp <> stndNew) then Exit;
			if Not(V.DefTyp = defCopy) then Exit;
			Nm := V.AParent;
			Goto Retry;
			end;
		TypeVar := TypeVar^.Next;
		end;
	Ident := Nm;
	Err(17);
end;

{****************************************************************************}
{ Dodanie typu. }

Procedure AddType(Nm: String; ST,DT: Byte; MS: LongInt; Pol: Byte;  RAL: Pointer;  Parent: String; EV: Byte);
var
	TypeVar: ^TypeRec;
	i: Byte;
	TV: TypeRec;
begin
	TypeVar := New(TypeRecSize);
	if (TypeVar = NIL) then Err(14);
	with TypeVar^ do begin
		Next := TypeList;
		Name := Nm;
		StndTyp := ST;
		DefTyp := DT;
		MemSize := MS;
		Pola := Pol;
		RecList := RAL;
		Dpth := Depth;
		AParent := Parent;
		Even := EV;
		InUnit := False;
		for i := 1 to 10 do AryTab[i] := AryWTab[i];
		if (MS = 0) then
			case dt of
				defCopy: begin
						GetType(Parent,False,TV);
						MemSize := TV.MemSize;
						end;
				defAry: begin
						GetType(Parent,False,TV);
						Even := TV.Even;
						MemSize := 1;
						for i := 1 to Pola do
							MemSize := MemSize*AryTab[i];
						MemSize := MemSize*TV.MemSize;
						MPSize := TV.MemSize;
						end;
				defRec:	MemSize := RecMemSize;
				defPtr: MemSize := 4;
				end;
				
		end;
	TypeList := TypeVar;
end;

{****************************************************************************}
{ Usuniecie typow na danym poziomie. }

Procedure RemType;
label
	Loop,Loop2,Skok1,Skok2;
var
	TypeVar: ^TypeRec;
	RecVar: ^OneRec;

	Procedure PutRecList;
	label
		Loop1,Loop2;
	var
		il,i: Byte;
	begin
		RecVar := TypeVar^.RecList;
		il := 1;
	Loop1:
		if (RecVar^.Next <> NIL) then begin
			Inc(il);
			RecVar := RecVar^.Next;
			Goto Loop1;
			end;
	Loop2:
		if (il = 1) then begin
			RecVar := TypeVar^.RecList;
			UnitErr := Write_(UnitFile,@RecVar^,OneRecSize);
			Exit;
			end;
		RecVar := TypeVar^.RecList;
		for i := 2 to il do
			RecVar := RecVar^.Next;
		UnitErr := Write_(UnitFile,@RecVar^,OneRecSize);
		Dec(il);
		Goto Loop2;
	end;

begin
Loop:
	TypeVar := TypeList;
	if (TypeVar = NIL) then Exit;
	if (TypeVar^.Dpth < Depth) then Exit;
	if CheckMem and (Depth = 0) then Exit;
	TypeList := TypeVar^.Next;
	if UnitFlush and (TypeVar^.stndTyp = stndNew) and Not(TypeVar^.InUnit) then begin
		TypeVar^.InUnit := True;
		WriteTxt(5);
		UnitErr := Write_(UnitFile,@TypeVar^,TypeRecSize);
		if (TypeVar^.DefTyp = defRec) then PutRecList;
		end;
Loop2:
	RecVar := TypeVar^.RecList;
	if (RecVar <> NIL) then begin
		TypeVar^.RecList := RecVar^.Next;
		Dispose(RecVar);
		Goto Loop2;
		end;
	Dispose(TypeVar);
	Goto Loop;
end;

{****************************************************************************}
{ Czy typ o podanej nazwie istnieje. }

Function AskType(Nm: String): Boolean;
var
	TypeVar: ^TypeRec;
begin
	TypeVar := TypeList;
	while (TypeVar <> NIL) do begin
		if (TypeVar^.Name = Nm) then begin
			AskType := True;
			Exit;
			end;
		TypeVar := TypeVar^.Next;
		end;
	AskType := False;
end;

{****************************************************************************}
{ Usuniecie zmiennych na danym poziomie. }

Procedure RemVar;
label
	Loop;
var
	VarVar: ^VarRec;
	H: String[20];
	HlpL: LongInt;

	Procedure CAdd;
	begin
		if VarVar^.AsemVar then Exit;
		if (VarVar^.Dpth > 0) then begin
			if UnitStat then begin	{!!!}
				Put('_');
				Put(UnitFN);
				end;
			Put('_');
			Str(VarVar^.Cntr,HTxt);
			Put(HTxt);
			end;
	end;

begin
Loop:
	VarVar := VarList;
	if (VarVar = NIL) then Exit;
	if (VarVar^.Dpth < Depth) then Exit;
	VarList := VarVar^.Next;
	if UnitFlush and Not(VarVar^.InUnit) then begin
		VarVar^.InUnit := True;
		WriteTxt(4);
		UnitErr := Write_(UnitFile,@VarVar^,VarRecSize);
		end
	else begin
		if VarVar^.AsemVar then Put(';');
		if (VarVar^.VarOp = opMem) then begin
			if (VarVar^.Even = 0) then begin
				Put(VarVar^.Name);
				CAdd;
				Put(':'#9'dcb.b'#9);
				end
			else begin
				PutL(#9#9'Even');
				Put(VarVar^.Name);
				CAdd;
				Put(':'#9'dcb.b'#9);
				end;
			Str(VarVar^.MSize,H);
			PutL(H);
			end;
		if (VarVar^.VarOp = opSts) or (VarVar^.VarOp = opStsPar) or (VarVar^.VarOp = opStsPtr) then begin
			Put(VarVar^.Name);
			CAdd;
			Put(#9'='#9);
			HlpL := VarVar^.AdrOfs;
			Str(HlpL,H);
			PutL(H);
			end;
		if (VarVar^.VarOp = opAdr) then begin
			Put(VarVar^.Name);
			CAdd;
			Put(#9'='#9);
			Str(VarVar^.AdrOfs,H);
			PutL(H);
			end;
		end;
	Dispose(VarVar);
	Goto Loop;
end;

{****************************************************************************}
{ Usuniecie stalych na danym poziomie. }

Procedure RemConst;
label
	Loop;
var
	CVar: ^ConstRec;
	H: String[20];
begin
Loop:
	CVar := ConstList;
	if (CVar = NIL) then Exit;
	if (CVar^.Dpth < Depth) then Exit;
	ConstList := CVar^.Next;
	if UnitFlush and Not(CVar^.InUnit) then begin
		CVar^.InUnit := True;
		WriteTxt(1);
		UnitErr := Write_(UnitFile,@CVar^,ConstRecSize);
		end
	else if Not(UnitStat) then begin
{
		Put(CVar^.Name);
		Put(#9'='#9);
		Str(CVar^.Value,H);
		PutL(H);
}
		end;
	Dispose(CVar);
	Goto Loop;
end;

{****************************************************************************}
{ Pobranie wartosci stalej. }

Function GetConst(Nm: String; var Val: LongInt): Boolean;
label
	Loop;
var
	CVar: ^ConstRec;
begin
	CVar := ConstList;
Loop:
	if (CVar = NIL) then begin
		GetConst := False;
		Exit;
		end;
	if (CVar^.Name = Nm) then begin
		Val := CVar^.Value;
		GetConst := True;
		Exit;
		end;
	CVar := CVar^.Next;
	Goto Loop;
end;

{****************************************************************************}
{ Usuniecie procedury lub funkcji na danym poziomie. }

Procedure RemPrFu;
label
	Loop,Loop2,Loop3;
var
	PF: ^PrFuRec;

	Procedure PutParamList;
	label
		Loop1,Loop2;
	var
		il,i: Byte;
	begin
		ParamVar := PF^.PList;
		il := 1;
	Loop1:
		if (ParamVar^.Next <> NIL) then begin
			Inc(il);
			ParamVar := ParamVar^.Next;
			Goto Loop1;
			end;
	Loop2:
		if (il = 1) then begin
			ParamVar := PF^.PList;
			UnitErr := Write_(UnitFile,@ParamVar^,ParamRecSize);
			Exit;
			end;
		ParamVar := PF^.PList;
		for i := 2 to il do
			ParamVar := ParamVar^.Next;
		UnitErr := Write_(UnitFile,@ParamVar^,ParamRecSize);
		Dec(il);
		Goto Loop2;
	end;

begin
Loop:
	PF := PrFuList;
	if (PF = NIL) then Exit;
	if (PF^.Dpth < Depth) then Exit;
	if CheckMem and (Depth = 0) then Exit;
	PrFuList := PF^.Next;
	if UnitFlush and Not(PF^.PFInUnit) then begin
		PF^.PFInUnit := True;
		WriteTxt(3);
		UnitErr := Write_(UnitFile,@PF^,PrFuRecSize);
		if (PF^.PList <> NIL) and UnitFlush then
		PutParamList;
		end;
Loop2:
	ParamVar := PF^.PList;
	if (ParamVar <> NIL) then begin
		PF^.PList := ParamVar^.Next;
		Dispose(ParamVar);
		Goto Loop2;
		end;
Loop3:
	UsedVar := PF^.UsedPFList;
	if (UsedVar <> NIL) then begin
		PF^.UsedPFList := UsedVar^.Next;
		if UnitFlush then begin
			UnitErr := Write_(UnitFile,@UsedVar^,UsedRecSize);
			end;
		Dispose(UsedVar);
		Goto Loop3;
		end;
	Dispose(PF);
	Goto Loop;
end;

{****************************************************************************}
{ Pobranie struktury procedury lub funkcji o podanej nazwie. }

Function GetPrFu(Nm: String; var PrFu: PrFuRec): Boolean;
label
	Loop;
var
	PF: ^PrFuRec;
begin
	PF := PrFuList;
Loop:
	if (PF = NIL) then begin
		GetPrFu := False;
		Exit;
		end;
	if (PF^.Name = Nm) then begin
		PrFu := PF^;
		if PrFu.PFInUnit then
			PF^.PFUsed := True;
		GetPrFu := True;
		Exit;
		end;
	PF := PF^.Next;
	Goto Loop;
end;

Procedure RemStr;
label
	Loop;
var
	StrVar: ^StrRec;
begin
Loop:
	StrVar := StrList;
	if (StrVar = NIL) then
		Exit;
	StrList := StrVar^.Next;
	if UnitFlush and (StrVar^.FromUnit = '') then begin
		StrVar^.FromUnit := UnitFN;
		WriteTxt(2);
		UnitErr := Write_(UnitFile,@StrVar^,StrRecSize);
		end
	else begin
		Put('_Str_');
		if (StrVar^.FromUnit <> '') then begin
			Put(StrVar^.FromUnit);
			Put('_');
			end;
		Str(StrVar^.Num,HTxt);
		Put(HTxt);
		Put(':'#9'dc.b'#9'''');
		Put(StrVar^.Txt);
		PutL(''',0');
		end;
	Dispose(StrVar);
	Goto Loop;
end;

Procedure RemUsedUnit;
var
	F: Text;
begin
	if Not(UnitFlush) then Exit;
	Assign(F,UnitDir+UnitFN+'.Unit');
	ReWrite(F);
	UsedVar := UsesUnitList;
	while (UsedVar <> NIL) do begin
		WriteLn(F,'UNIT');
		WriteLn(F,UsedVar^.Name);
		WriteLn(F);
		UsedVar := UsedVar^.Next;
		end;
	WriteLn(F,UnitFN);
	Close(F);
end;

{****************************************************************************}
{ Procedura konczaca. }

Procedure Stop(CzyOK: Boolean);
begin
	if CzyOK then begin
		UnitFlush := UnitStat;
		Depth := 0;
		RemType;
		RemVar;
		RemStr;
		RemConst;
		RemPrFu;
		RemUsedUnit;
		if UnitStat then WriteTxt(0);
		if Not(UnitStat) then begin
			PutL(#9#9'Even');
			PutL('GlobalStack:'#9'dcb.b'#9'4');
			PutL('');
			end;
		PutL(#9#9'End');
		end;
	Close_(InFile);
	CloseOut;
	if UnitFile <> 0 then Close_(UnitFile);
	FreeAll;
end;

{****************************************************************************}
{ Blad kompilacji. }

Procedure Err(Num: Byte);
var
	t: String;
begin
	WriteLn('Error: ',Num,'  at Line: ',LineCnt);
	Write('In File: ');
	if MainFile then
		WriteLn(SrcFN)
	else
		WriteLn(InclFN);
	WriteLn;
	Write(#9'> ');
	case Num of
		0: t := 'Brak pliku zrodlowego.';
		1: t := 'Niedomkniety komentarz.';
		2: t := 'Zly zapis liczby HEX.';
		3: t := 'Zly zapis liczby BIN.';
		4: t := 'Zly zapis liczby TXT.';
		5: t := 'Zly zapis liczby DEC.';
		6: t := 'Niespodziewany koniec pliku.';
		7: t := 'Wymagana liczba dziesietna bez znaku.';
		8: t := 'Wymagany identyfikator: '+ErrT;
		9: t := 'Wymagany identyfikator.';
		10: t := 'Nieznana instrukcja.';
		11: t := 'Wymagany znak: '+ErrT;
		12: t := 'Niedozwolona instrukcja: '+ErrT;
		13: t := 'Za dlugi identyfikator.';
		14: t := 'Brak pamieci.';
		15: t := 'Typ juz istnieje: '+Ident;
		16: t := 'Wymagana nazwa typu tablicy.';
		17: t := 'Taki typ nie istnieje: '+Ident;
		18: t := 'Wymagana liczba.';
		19: t := 'Znak [ lub , .';
		20: t := 'Za duzo pol tablicy.';
		21: t := 'Znak , lub ; .';
		22: t := 'Brak pol w rekordzie.';
		23: t := 'Taka zmienna juz jest: '+Ident;
		24: t := 'Znak ; lub , lub = .';
		25: t := 'Taka stala juz jest: '+Ident;
		26: t := 'Znak = .';
		27: t := 'Znak ( lub ; .';
		28: t := 'Znak ) .';
		29: t := 'W definicji parametru moze byc tylko VAR.';
		30: t := 'Funkcja nie moze byc tak wywolana.';
		31: t := 'Instrukcja THEN.';
		32: t := 'Tu nie moze byc etykiety.';
		33: t := 'Blad w zapisie wyrazenia.';
		34: t := 'Za duzo otwartych nawiasow.';
		35: t := 'Za duzo zamknietych nawiasow.';
		36: t := 'Brak przypisania.';
		37: t := 'Powtorzony znak przypisania.';
		38: t := 'Znak minus powtorzony.';
		39: t := 'Znak @ lub ~ niedozwolony.';
		40: t := 'Blad w wyrazeniu - brak identyfikatora.';
		41: t := 'Rozmiar nie moze dotyczyc PROC, FUNC.';
		42: t := 'W wyrazeniu nie moze byc procedury.';
		43: t := 'Nieznane dzialanie lub funkcja.';
		44: t := 'Znak ( .';
		45: t := 'Niedozwolony przecinek.';
		46: t := 'Niedozwolony ) .';
		47: t := 'Niedozwolony ] .';
		48: t := 'Parametrem docelowym moze byc tylko zmienna.';
		49: t := 'Blad systemu.';
		50: t := 'Nieznana zmienna, procedura.';
		51: t := 'W wyrazeniu moga byc tylko zmienne typu prostego.';
		52: t := 'Ta zmienna nie jest wskaznikiem.';
		53: t := 'Zmienna nie jest rekordem.';
		54: t := 'Zmienna nie jest tablica.';
		55: t := 'Brak taiego pola w rekordzie.';
		56: t := 'Brak wolnego rejestru.';
		57: t := 'Zmienna zrodlowa i docelowa sa roznego typu.';
		58: t := 'To jest procedura, a nie funkcja.';
		59: t := 'Blad w kompilacji dostepu do zmiennej.';
		60: t := 'Ten typ nie jest rekordem.';
		61: t := 'Ten typ nie jest tablica.';
		62: t := 'Brak pola w rekordzie o tej nazwie.';
		63: t := 'Brak wartosci typu prostego.';
		64: t := 'Nie statyczny dostep do zmiennej.';
		65: t := 'Wymagane kolejne pole w tablicy.';
		66: t := 'Tablica ma mniej pol.';
		67: t := 'Blad w kompilacji adresu zmiennej.';
		68: t := 'Brak w kompilatorze dlugiego mnozenia.';
		69: t := 'Nieznana funkcja.';
		70: t := 'Brak parametrow.';
		71: t := 'Niedozwolona liczba rotacji.';
		72: t := 'Funkcja nieczynna.';
		73: t := 'Wymagany parametr dla NOT.';
		74: t := 'Zbyt dlugi tekst.';
		75: t := 'Wymagany parametr.';
		76: t := 'Blad zapisu po znaku :+ lub :- .';
		77: t := 'Tu nie moze byc przypisania.';
		78: t := 'W warunku musi byc typ prosty.';
		79: t := 'Blad kompilacji warunku.';
		80: t := 'Wymagane ELSEIF lub ELSE.';
		81: t := 'Nieznana funkcja.';
		82: t := 'Tu nie moze byc procedury.';
		83: t := 'Wymagany UNTIL.';
		84: t := 'Wymagane PROC lub FUNC.';
		85: t := 'Wymagana zmienna lub funkcja.';
		86: t := 'Wymagana stala lub ENDCASE.';
		87: t := 'Wymagana liczba.';
		88: t := 'Brak petli do przerwania.';
		89: t := 'Wymagany ; lub Stala.';
		90: t := 'Blad po znaku specjalnym.';
		91: t := 'Brak stalej po znaku specjalnym.';
		92: t := 'Niespodziewany EOF w bloku asemblera.';
		93: t := 'Wymagany , lub ;';
		94: t := 'Wymagany typ zlozony.';
		95: t := 'Wymagana zmienna innego typu.';
		96: t := 'Nieznana proc, func.';
		97: t := 'Brak opisu typu parametru.';
		98: t := 'Brak parametru.';
		99: t := 'Nie moge znalezc takiego UNIT-u: '+Ident;
		100: t := 'Nie znana Proc, Func w LINKPF: '+Ident;
		101: t := 'Brak bloku glownego unitu: '+Ident;
		102: t := 'To nie jest unit PCA.';
		103: t := 'Nieznany header.';
		104: t := 'Brak headera opisu rekordu w typie.';
		105: t := 'Brak headera opisu parametru.';
		106: t := 'Brak headera uzytych proc,func.';
		107: t := 'Wymagana nazwa typu, PTR, ARRAY, RECORD.';
		108: t := 'Wymagana nazwa typu pola rekordu.';
		109: t := 'Wymagana nazwa typu wskaznika.';
		110: t := 'Wymagana nazwa pola rekordu.';
		end;
	WriteLn(t);
	WriteLn;
	Stop(False);
	WriteLn('Compile not successfull.');
	Halt;
end;

{****************************************************************************}
{ Dodanie procedury lub funkcji. }

Procedure AddPrFu(PrFu: PrFuRec);
var
	PF: ^PrFuRec;
begin
	PF := New(PrFuRecSize);
	if (PF = NIL) then Err(14);
	PrFu.Next := PrFuList;
	PrFu.Dpth := Depth;
	PrFu.Start := 0;
	PrFu.Stop := 0;
	PrFu.UsedPFList := NIL;
	PrFu.PFInUnit := False;
	PrFu.IlUsed := 0;
	PF^ := PrFu;
	PrFuList := PF;
end;

{****************************************************************************}
{ Dodanie stalej. }

Procedure AddConst(Nm: String;  Val: LongInt);
var
	CVar: ^ConstRec;
begin
	CVar := New(ConstRecSize);
	if (CVar = NIL) then Err(14);
	CVar^.Next := ConstList;
	CVar^.Dpth := Depth;
	CVar^.Name := Nm;
	CVar^.Value := Val;
	CVar^.InUnit := False;
	ConstList := CVar;
end;

{****************************************************************************}
{ Pobranie dlugosci pliku }

Function FileS(Nm: String): LongInt;
var
	F: File of Byte;
	H: LongInt;
begin
	Assign(F,Nm);
	Reset(F);
	H := FileSize(F);
	Close(F);
	FileS := H;
end;

{****************************************************************************}
{ Inicjacja kompilatora. }

Procedure Start;
var
	CF: File of Byte;
	CFS,CCnt: LongInt;
	txtDD,txtSUD,txtUD,txtUN,txtI,txtSD,txtSN,txtDN: String[80];

	Procedure AI(INr: Byte; Nm: String);
	begin
		InstrTab[INr].Name := Nm;
		InstrTab[INr].INum := INr;
	end;

	Function G: Char;
	var
		HB: Byte;
		C: Char;
	begin
		if (CCnt = CFS) then begin
			G := Chr(0);
			Exit;
			end;
		Read(CF,HB);
		C := Chr(HB);
		C := UpCase(C);
		Inc(CCnt);
		G := C;
	end;

	Procedure GetConfigData;
	label
		Loop1,Loop2,Loop3,Loop4,Loop5;
	var
		S,T: String[80];
		C: Char;
		B: Byte;
	begin
		T := '';
	Loop2:
		S := '';
	Loop1:
		C := G;
		B := Ord(C);
	Loop4:
		if (C = ';') then Goto Loop5;
		if (B = 32) or (B = 10) or (B = 0) or (B = 9) then begin
			if (T = '') then begin
				T := S;
				if (B <> 0) then Goto Loop3;
				end;
			if (T = 'INSTALL') then opInst := True;
			if (T = 'UNITDIR') then txtUD := S;
			if (T = 'UNITNAME') then txtUN := S;
			if (T = 'INCLUDE') then txtI := S;
			if (T = 'SOURCEDIR') then txtSD := S;
			if (T = 'SOURCENAME') then txtSN := S;
			if (T = 'DESTNAME') then txtDN := S;
			if (T = 'DESTDIR') then txtDD := S;
			if (T = 'SOURCEUNITDIR') then txtSUD := S;
			if (T = 'TEMPORARY') then txtTmp := S;
			T := '';
			if (B <> 0) then Goto Loop2;
			Exit;
			end;
		S := S+C;
		Goto Loop1;
	Loop3:
		C := G;
		B := Ord(C);
		if (B = 0) then Exit;
		if (B = 32) or (B = 10) or (B = 9) then Goto Loop3;
		S := '';
		Goto Loop4;
	Loop5:
		C := G;
		B := Ord(C);
		if (B = 0) then Exit;
		if (B <> 10) then Goto Loop5;
		Goto Loop2;
	end;

begin
	txtUD	:= 	'';
	txtUN	:=	'';
	txtI	:=	'';
	txtSD	:=	'';
	txtSN	:=	'';
	txtDN	:=	'';
	txtSUD	:=	'';
	txtDD	:=	'';
	txtTmp	:=	'';

	CFS := FileS(ConfigFN);

	if (CFS = 0) then begin
		WriteLn('No config file.');
		Halt;
		end;

	CCnt := 0;
	Assign(CF,ConfigFN);
	Reset(CF);
	GetConfigData;
	Close(CF);

	InclFN := txtI;
	UnitFN := txtUN;
	UnitDir := txtUD;

	if (txtUN <> '') then begin
		SrcFN := txtSUD+txtUN+'.pca';
		DstFN := txtUD+txtUN+'.s';
		end
	else begin
		SrcFN := txtSD+txtSN+'.pca';
		DstFN := txtDD+txtDN+'.s';
		end;

	WriteLn('Compile...');

	Depth := 0;
	PFCounter := 0;
	JumpCnt := 1;
	StringCnt := 1;
	FirstPF := True;
	TypeList := NIL;
	VarList := NIL;
	ConstList := NIL;
	PrFuList := NIL;
	StrList := NIL;
	BreakList := NIL;
	UsesUnitList := NIL;
	UFUList := NIL;
	MemoryList := NIL;
	MainFile := False;

	FS := FileS(InclFN);
	InFile := Open(InclFN,1005);
	FileCnt := 32767;
	LineCnt := 1;
	FCnt := 1;
	BackS := False;
	if (FS = 0) then begin
		Close_(InFile);
		MainFile := True;
		FS := FileS(SrcFN);
		InFile := Open(SrcFN,1005);
		FileCnt := 32767;
		LineCnt := 1;
		if (FS = 0) then Err(0);
		end;

	OutFile := Open(DstFN,1006);
	OutFileCnt := 0;
	OutFCnt := 0;

	SpecTab[1]	:=	':=';
	SpecTab[2]	:=	'<>';
	SpecTab[3]	:=	'>=';
	SpecTab[4]	:=	'<=';
	SpecTab[5]	:=	'//';
	SpecTab[6]	:=	'<<';
	SpecTab[7]	:=	'>>';
	SpecTab[8]	:=	'++';
	SpecTab[9]	:=	'--';
	SpecTab[10]	:=	':+';
	SpecTab[11]	:=	':-';

	AI(1,'UNIT');
	AI(2,'USES');
	AI(3,'BREAK');
	AI(4,'OPTIONS');
	AI(5,'IFNZ');
	AI(6,'IFZ');
	AI(7,'LOOP');
	AI(8,'ARRAY');
	AI(9,'RECORD');
	AI(10,'PTR');
	AI(11,'BEGIN');
	AI(12,'END');
	AI(13,'CONST');
	AI(14,'TYPE');
	AI(15,'VAR');
	AI(16,'ASM');
	AI(17,'IFCASE');
	AI(18,'PROC');
	AI(19,'FUNC');
	AI(20,'AND');
	AI(21,'OR');
	AI(22,'NOT');
	AI(23,'FOR');
	AI(24,'TO');
	AI(25,'STEP');
	AI(26,'DO');
	AI(27,'CASE');
	AI(28,'OF');
	AI(29,'WHILE');
	AI(30,'REPEAT');
	AI(31,'UNTIL');
	AI(32,'FORWARD');
	AI(33,'APROC');
	AI(34,'AFUNC');
	AI(35,'IF');
	AI(36,'THEN');
	AI(37,'ELSE');
	AI(38,'ELSEIF');
	AI(39,'GOTO');
	AI(40,'EXIT');
	AI(41,'HALT');
	AI(42,'ENDCASE');
	AI(43,'LINKPF');

	MMList := MemoryList;

	if (Leek = NIL) or UnitStat or Not(opInst) then begin
		AddType('Byte',stndByte,0,1,0,NIL,'',0);
		AddType('UByte',stndUByte,0,1,0,NIL,'',0);
		AddType('Word',stndWord,0,2,0,NIL,'',1);
		AddType('UWord',stndUWord,0,2,0,NIL,'',1);
		AddType('Long',stndLong,0,4,0,NIL,'',1);
		AddType('ULong',stndULong,0,4,0,NIL,'',1);
		end;
end;

{****************************************************************************}
{ Cofniecie o jeden znak w pliku zrodlowym. }

Procedure Back;
begin
	Dec(FCnt);
	BackS := True;
end;

{****************************************************************************}
{ Pobranie znaku z pliku zrodlowego. }

Function GetC: Char;
label
	Jump;
var
	Hlp,Dana: Byte;
	ErrW: Word;
begin
	if (FCnt = FS) then begin
		if MainFile then begin
			BackV := 0;
			GetC := Chr(0);
			Exit;
			end
		else begin
			Close_(InFile);
			FS := FileS(SrcFN);
			MainFile := True;
			InFile := Open(SrcFN,1005);
			FileCnt := 32767;
			if (FS = 0) then Err(0);
			FCnt := 0;
			LineCnt := 1;
			BackS := False;
			Goto Jump;
			end;
		end;
	if BackS then begin
		Hlp := BackV;
		BackS := False;
		Inc(FCnt);
		end
	else begin
Jump:
		if (FileCnt > FileBuf) then begin
			FileCnt := 1;
			UnitErr := Read_(InFile,@Bufor,FileBuf);
			end;
		Hlp := Bufor[FileCnt];
		Inc(FileCnt);
		BackV := Hlp;
		Inc(FCnt);
		if (Hlp = 10) then Inc(LineCnt);
		end;
	GetC := Chr(Hlp);
end;

{****************************************************************************}
{ Pobranie znaku, etykiety, stalej, znaku specjalnego z pliku zrodlowego. }

Function Get: Byte;
label
	Skok1,Skok2,Skok3,Skok4;
var
	Hlp,MHlp: Char;
	RemCnt,k: Byte;
	Znak: LongInt;

	{ *** Pobranie liczby dziesietnej. *** }
	Procedure GetValDec;
	label
		Jump1;
	begin
		k := 1;
		Value := Ord(Hlp)-48;
	Jump1:
		Hlp := GetC;
		if Cyf(Hlp) then begin
			if (k = 10) then Err(5);
			Value := (Value*10)+(Ord(Hlp)-48);
			Inc(k);
			Goto Jump1;
			end;
		Back;
		Value := Value*Znak;
	end;

	{ *** Pobranie liczby binarnej. *** }
	Procedure GetValBin;
	label
		Jump1;
	begin
		k := 0;
		Value := 0;
	Jump1:
		Hlp := GetC;
		if BCyf(Hlp) then begin
			if (k = 32) then Err(3);
			Value := (Value shl 1) + (Ord(Hlp)-48);
			Inc(k);
			Goto Jump1;
			end;
		if (k = 0) then Err(3);
		Value := Value*Znak;
		Back;
	end;

	{ *** Pobranie liczby hexadecymalnej. *** }
	Procedure GetValHex;
	label
		Jump1;
	var
		H: Byte;
	begin
		k := 0;
		Value := 0;
	Jump1:
		Hlp := UpCase(GetC);
		if HCyf(Hlp) then begin
			if (k = 8) then Err(2);
			H := Ord(Hlp)-48;
			if (H > 9) then Dec(H,7);
			Value := (Value shl 4)+H;
			Inc(k);
			Goto Jump1;
			end;
		if (k = 0) then Err(2);
		Value := Value*Znak;
		Back;
	end;

	{ *** Pobranie liczby text. *** }
	Procedure GetValTxt;
	label
		Jump1,Jump2;
	var
		Val: LongInt;
		i,MZnak: Byte;
	begin
		i := 0;
		Val := 0;
		MZnak := Znak;
		Znak := 1;
	Jump1:
		Hlp := GetC;
		if (Hlp = '''') then begin
			if (i = 4) then Err(4);
	Jump2:
			Hlp := GetC;
			if (Hlp = '''') then Goto Jump1;
			if (i = 4) then Err(4);
			Val := (Val shl 8)+Ord(Hlp);
			Inc(i);
			Goto Jump2;
			end;
		if (Hlp = '#') then begin
			Hlp := GetC;
			if not(Cyf(Hlp)) then Err(7);
			if (i = 4) then Err(4);
			GetValDec;
			Val := (Val shl 8)+Value;
			Inc(i);
			Goto Jump1;
			end;
		Back;
		Value := Val*MZnak;
	end;

begin
	RemCnt := 0;
Skok1:
	Hlp := GetC;
	if (Hlp = #0) then begin
		if (RemCnt > 0) then Err(1);
		Get := gtEOF;
		Exit;
		end;
	if (Hlp <= #32) then Goto Skok1;
	if (Hlp = '{') then begin
		Inc(RemCnt);
		Goto Skok1;
		end;
	if (Hlp = '}') then begin
		Dec(RemCnt);
		Goto Skok1;
		end;
	if (RemCnt > 0) then Goto Skok1;
	if Lit(Hlp) then begin
		Ident := Hlp;
		Skok2:
		Hlp := GetC;
		if not(LitCyf(Hlp)) then
			if (Hlp = ':') then begin
				if (Length(Ident) > 20) then Err(13);
				Get := gtEtyk;
				Exit;
				end
			else begin
				if (Length(Ident) > 20) then Err(13);
				{UpStr(Ident);}
				Back;
				if GetConst(Ident,Value) then
					Get := gtValue
				else
					Get := gtIdent;
				Exit;
				end;
		Ident := Ident+Hlp;
		Goto Skok2;
		end;
	Znak := 1;
Skok4:
	if Cyf(Hlp) then begin
		GetValDec;
		Get := gtValue;
		Exit;
		end;
	if (Hlp = '%') then begin
		GetValBin;
		Get := gtValue;
		Exit;
		end;
	if (Hlp = '$') then begin
		GetValHex;
		Get := gtValue;
		Exit;
		end;
	if (Hlp = '#') or (Hlp = '''') then begin
		Back;
		GetValTxt;
		Get := gtValue;
		Exit;
		end;
	MHlp := GetC;
	if (Hlp = '-') and (Cyf(MHlp) or (MHlp = '%') or (MHlp = '$') or (MHlp = '#') or (MHlp = '''')) then begin
		Hlp := MHlp;
		Znak := -1;
		Goto Skok4;
		end;
	Ident := Hlp+MHlp;
	k := 1;
Skok3:
	if (SpecTab[k] = Ident) then begin
		GVar := k;
		Get := gtSpec;
		Exit;
		end;
	Inc(k);
	if (k <= IlSpec) then Goto Skok3;
	Back;
	Ident := Hlp;
	Get := gtZnak;
end;

{****************************************************************************}
{ Bezposrednie wyslanie czesci asemblera do pliku docelowego. }

Procedure PutASM;
label
	Loop1,Loop2,Loop3;
var
	C: Char;
	t1,t2: String[4];
	i: Byte;

	Function Get: Char;
	var
		C: Char;
	begin
		C := GetC;
		if (C = #0) then Err(92);
		Get := C;
	end;

begin
Loop1:
	C := Get;
	if Not(Lit(C)) then begin
		Put(C);
		Goto Loop1;
		end;
	t1 := C;

	C := Get;
	if Not(Lit(C)) then Goto Loop2;
	t1 := t1+C;

	C := Get;
	if Not(Lit(C)) then Goto Loop2;
	t1 := t1+C;

	C := Get;
	if (C <> ';') then Goto Loop2;
	t1 := t1+C;

	t2 := t1;
	UpStr(t2);
	if (t2 = 'END;') then begin
		Back;
		PutL('');
		Exit;
		end;
	Put(t1);
	Goto Loop3;
Loop2:
	Put(t1);
	Put(C);
	if (C = #10) then Goto Loop1;
Loop3:
	C := Get;
	Put(C);
	if (C <> #10) then Goto Loop3;
	Goto Loop1;
end;

Procedure FlushToEOF;
label
	Loop,Retry;
var
	C: Char;
	F: File of Byte;
	B: Byte;
	V: ^UsedRec;
begin
	if UnitStat then begin
		HTxt := UnitDir+UnitFN+'.Asm';
		Assign(F,HTxt);
		ReWrite(F);
Retry:
		C := GetC;
		B := Ord(C);
		if (B = 0) then begin
			Close(F);
			Exit;
			end;
		Write(F,B);
		Goto Retry;
		end;
	V := UsesUnitList;
	while (V <> NIL) do begin
		HTxt := UnitDir+V^.Name+'.Asm';
		if (FileS(HTxt) <> 0) then begin
			Put(#9#9'INCLUDE'#9);
			PutL(HTxt);
			end;
		V := V^.Next;
		end;
	if (UsesUnitList <> NIL) then PutL('');
Loop:
	C := GetC;
	if (C = #0) then Exit;
	Put(C);
	Goto Loop;
end;

{****************************************************************************}
{ Wymagana instrukcja o podanym numerze. }

Procedure MustINr(Nr: Byte);
begin
	if (Get <> gtIdent) then begin
		ErrT := InstrTab[Nr].Name;
		Err(8);
		end;
	if (Ident <> InstrTab[Nr].Name) then begin
		ErrT := InstrTab[Nr].Name;
		Err(8);
		end;
end;

{****************************************************************************}
{ Wymagany dowolny identyfikator. }

Procedure MustIdent;
begin
	if (Get <> gtIdent) then Err(9);
end;

{****************************************************************************}
{ Wymagany podany znak. }

Procedure MustChar(C: Char);
begin
	if (Get <> gtZnak) then begin
		ErrT := C;
		Err(11);
		end;
	if (Ident <> C) then begin
		ErrT := C;
		Err(11);
		end;
end;

{****************************************************************************}
{ Odszukanie numeru instrukcji o nazwie w Ident. }

Function FindI: Byte;
label
	Loop;
var
	k: Byte;
	iden: string[20];
begin
	iden := ident;
	UpStr(iden);
	k := 1;
Loop:
	if (InstrTab[k].Name = Iden) then begin
		FindI := k;
		Exit;
		end;
	Inc(k);
	if (k <= IlInstr) then Goto Loop;
	FindI := 0;
end;

{****************************************************************************}
{ Dodanie zmiennej. }

Procedure AddVar(VR: VarRec);
var
	VRP: ^VarRec;
begin
	VRP := New(VarRecSize);
	if (VRP = NIL) then Err(14);
	VR.Next := VarList;
	VR.Dpth := Depth;
	VR.Cntr := PFCounter;
	VR.AsemVar := AsemStat;
	VR.InUnit := False;
	VRP^ := VR;
	VarList := VRP;
end;

{****************************************************************************}
{ Czy taka zmienna istnieje. }

Function AskVar(Nm: String;  var SameDpth: Boolean): Boolean;
label
	Loop;
var
	VR: ^VarRec;
begin
	VR := VarList;
Loop:
	if (VR = NIL) then begin
		AskVar := False;
		Exit;
		end;
	if (VR^.Name = Nm) then begin
		SameDpth := False;
		if (VR^.Dpth = Depth) then SameDpth := True;
		AskVar := True;
		Exit;
		end;
	VR := VR^.Next;
	Goto Loop;
end;

{****************************************************************************}
{ Pobranie struktury zmiennej o podanej nazwie. }

Procedure GetVar(Nm: String; var VR: VarRec);
label
	Loop;
var
	VRP: ^VarRec;
begin
	VRP := VarList;
Loop:
	if (VRP = NIL) then begin
		VR.VarOp := opUnk;
		Exit;
		end;
	if (VRP^.Name = Nm) then begin
		VR := VRP^;
		Exit;
		end;
	VRP := VRP^.Next;
	Goto Loop;
end;

{****************************************************************************}
{ Odnalezienie struktury typu dla podanej zmiennej. }

Procedure FindVType(Nm: String; var TR: TypeRec);
label
	Loop;
var
	VRP: ^VarRec;
	TNm: String[20];
begin
	VRP := VarList;
Loop:
	if (VRP = NIL) then Exit;
	if (VRP^.Name <> Nm) then begin
		VRP := VRP^.Next;
		Goto Loop;
		end;
	TNm := VRP^.TName;
	GetType(TNm,True,TR);
end;

{ *** Zwolnienie mozliwych do uzycia rejestrow. *** }
Procedure ClrRegs;
var
	i: Byte;
begin
	DRMin := 0;
	DRMax := 7;
	ARMin := 0;
	ARMax := 5;
	for i := 0 to 7 do begin
		DRTab[i,0] := True;
		ARTab[i,0] := True;
		end;
	for i := DRMin to DRMax do
		DRTab[i,0] := False;
	for i := ARMin to ARMax do
		ARTab[i,0] := False;
end;

{ *** Ustawienie etykiety skoku. *** }
Procedure SetJump;
var
	H,JumpT: String[20];
begin
	JumpT := '';
	if (Depth <> 0) and UnitStat then
		JumpT := '_'+UnitFN;
	Str(JumpCnt,H);
	JumpT := JumpT+'_'+H;
	Put(JumpT);
	PutL(':');
	Inc(JumpCnt);
end;

{ *** Ustawienie etykiety skoku bez zmiany numeru skoku. *** }
Procedure SetJump2(V: LongInt);
var
	H,JumpT: String[20];
begin
	JumpT := '';
	if (Depth <> 0) and UnitStat then
		JumpT := '_'+UnitFN;
	Str(V,H);
	JumpT := JumpT+'_'+H;
	Put(JumpT);
	PutL(':');
end;

Function AllocJump: LongInt;
begin
	Inc(JumpCnt);
	AllocJump := JumpCnt-1;
end;

Procedure AddStr(T: String);
var
	StrVar: ^StrRec;
begin
	StrVar := New(StrRecSize);
	if (StrVar = NIL) then Err(14);
	StrVar^.Next := StrList;
	StrList := StrVar;
	StrVar^.Num := StringCnt;
	StrVar^.Txt := T;
	StrVar^.FromUnit := '';
	Inc(StringCnt);
end;

{****************************************************************************}
{ Zamiana typu na rozmiar zajmowany przez typ. }

Function TypeToSize(nm: Byte): Byte;
var
	n: Byte;
begin
	case nm of
		stndByte:	n := siByte;
		stndUByte:	n := siByte;
		stndWord:	n := siWord;
		stndUWord:	n := siWord;
		stndLong:	n := siLong;
		stndULong:	n := siLong;
		end;
	TypeToSize := n;
end;

Procedure PutRegs(Rg: LongInt);
label
	Loop1,Loop2;
var
	i,n: Byte;
	F: Boolean;
begin
	i := 0;
	n := 0;
	if BTst(16,Rg) then begin
	Loop1:
		if BTst(i,Rg) then begin
			if (n < 8) then begin
				Put('d');
				Str(n,HTxt);
				Put(HTxt);
				Exit;
				end
			else begin
				Put('a');
				Str(n-8,HTxt);
				Put(HTxt);
				Exit;
				end;
			end;
		Inc(n);
		Inc(i);
		Goto Loop1;
		end
	else begin
		i := 0;
		n := 0;
		F := False;
	Loop2:
		if BTst(i,Rg) then begin
			if F then Put('/');
			F := True;
			if (n < 8) then begin
				Put('d');
				Str(n,HTxt);
				Put(HTxt);
				end
			else begin
				Put('a');
				Str(n-8,HTxt);
				Put(HTxt);
				end;
			end;
		Inc(i);
		Inc(n);
		if (i < 16) then Goto Loop2;
		end;
end;

Function PushRegs: LongInt;
var
	H: LongInt;
	IlA,IlD,i: Byte;
begin
	H := 0;
	IlA := 0;
	IlD := 0;
	for i := DRMin to DRMax do
		if DRTab[i,0] then begin
			Inc(IlD);
			BSet(i,H);
			end;
	for i := ARMin to ARMax do
		if ARTab[i,0] then begin
			Inc(IlA);
			BSet(i+8,H);
			end;
	if ((IlA + IlD) = 0) then begin
		PushRegs := 0;
		Exit;
		end;
	if ((IlA + IlD) = 1) then begin
		BSet(16,H);
		Put(#9#9'move.l'#9);
		end
	else
		Put(#9#9'movem.l'#9);
	PutRegs(H);
	PutL(',-(sp)');
	PushRegs := H;
end;

Procedure PopRegs(Rg: LongInt);
begin
	if (Rg = 0) then Exit;
	if BTst(16,Rg) then
		Put(#9#9'move.l'#9'(sp)+,')
	else
		Put(#9#9'movem.l'#9'(sp)+,');
	PutRegs(Rg);
	PutL('');
end;

{****************************************************************************}
{ Pobranie i zarezerwowanie wolnego rejestru. }

Function AllocReg(DA: Boolean; si: Byte): Byte;
label
	Loop1,Loop2,Error;
var
	bsi: Boolean;
	i: Byte;
begin
	case TypeToSize(si) of
		siByte: bsi := False;
		siWord: bsi := False;
		siLong: bsi := True;
		end;
	i := 0;
	if DA then begin
Loop1:
		if (i = 8) then Goto Error;
		if DRTab[i,0] then begin
			Inc(i);
			Goto Loop1;
			end;
		DRTab[i,0] := True;
		DRTab[i,1] := bsi;
		AllocReg := i;
		Exit;
		end
	else begin
Loop2:
		if (i = 8) then Goto Error;
		if ARTab[i,0] then begin
			Inc(i);
			Goto Loop2;
			end;
		ARTab[i,0] := True;
		ARTab[i,1] := bsi;
		AllocReg := i;
		Exit;
		end;
Error:
	Err(56);
end;

{****************************************************************************}
{ Zwolnienie rejestru. }

Procedure FreeReg(DA: Boolean;  Nm: Byte);
begin
	if DA then
		DRTab[Nm,0] := False
	else
		ARTab[Nm,0] := False;
end;

{****************************************************************************}
{ Kompilacja bloku stalych }

Procedure CompConst;
label
	Loop;
var
	Val: LongInt;
	CName: String[20];
begin
Loop:
	if (Get <> gtIdent) then Err(9);
	CName := Ident;
	INr := FindI;
	if (INr <> 0) then Exit;
	if GetConst(Ident,Val) then Err(25);
	if (Get <> gtZnak) then Err(26);
	if (Ident <> '=') then Err(26);
	if (Get <> gtValue) then Err(18);
	AddConst(CName,Value);
	MustChar(';');
	Goto Loop;
end;

{****************************************************************************}
{ Kompilacja definicji zmiennych. }

Procedure CompVar(Param: Boolean);
label
	Loop,Loop1,Loop2;
var
	MC: Char;
	TName: String[20];
	PoVar: Boolean;
	gt: Byte;
	Hlp: ^ParamRec;
begin
	PoVar := False;
Loop:
	gt := Get;
	if Not(Param) then begin
		if (gt <> gtIdent) then Err(9);
		end
	else begin
		if (gt = gtZnak) then Exit;
		if (gt <> gtIdent) then Err(9);
		end;
	INr := FindI;
	if (INr <> 0) and Not(Param) then Exit;
	if not(PoVar) and (INr = 15) then begin
		PoVar := True;
		Goto Loop;
		end;
	if not(AskType(Ident)) then Err(17);
	GetType(Ident,False,TypeVar);
	TName := Ident;
Loop1:
	VarVar.TName := TName;
	if (Get <> gtIdent) then Err(9);
	if AskVar(Ident,HlpB) then
		if HlpB then Err(23);
	VarVar.Name := Ident;
	if (Get <> gtZnak) then Err(24);
	MC := Ident[1];
	VarVar.VarOp := opMem;
	if (MC = '=') then begin
		if (Get <> gtValue) then Err(18);
		VarVar.AdrOfs := Value;
		VarVar.VarOp := opAdr;
		if (Get <> gtZnak) then Err(21);
		MC := Ident[1];
		end;
	if (Depth > 0) AND (VarVar.VarOp = opMem) then
		if Not(Param) then begin
			VarVar.VarOp := opSts;
			PFPtr := PrFuList;
			PrFuVar := PFPtr^;
			if (TypeVar.Even = 1) then
				EEven(PrFuVar.StackPtr);
			VarVar.AdrOfs := -PrFuVar.StackPtr-TypeVar.MemSize;
			Inc(PrFuVar.StackPtr,TypeVar.MemSize);
			PFPtr^ := PrFuVar;
			end
		else begin
			ParamVar := New(ParamRecSize);
			if (ParamVar = NIL) then Err(14);
			ParamVar^.PoVar := PoVar;
			ParamVar^.Next := NIL;

			if (PrFuVar.PList = NIL) then
				PrFuVar.PList := ParamVar
			else begin
				Hlp := PrFuVar.PList;
Loop2:
				if (Hlp^.Next <> NIL) then begin
					Hlp := Hlp^.Next;
					Goto Loop2;
					end;
				Hlp^.Next := ParamVar;
				end;

			Inc(PrFuVar.IlP);
			ParamVar^.TName := TName;
			if Not(PoVar) then begin
				VarVar.VarOp := opStsPar;
				if (TypeVar.Even = 1) then
					EEven(PrFuVar.StackPar);
				VarVar.AdrOfs := PrFuVar.StackPar+8;
				if (Depth > 1) then
					Inc(VarVar.AdrOfs,4);
				if PrFuVar.FuStat then
					Inc(VarVar.AdrOfs,4);
				Inc(PrFuVar.StackPar,TypeVar.MemSize);
				end
			else begin
				VarVar.VarOp := opStsPtr;
				if (Depth > 1) then
					Inc(VarVar.AdrOfs,4);
				if PrFuVar.FuStat then
					Inc(VarVar.AdrOfs,4);
				EEven(PrFuVar.StackPar);
				VarVar.AdrOfs := PrFuVar.StackPar+8;
				Inc(PrFuVar.StackPar,4);
				end;
			end;
	VarVar.MSize := TypeVar.MemSize;
	VarVar.Even := TypeVar.Even;
	AddVar(VarVar);
	if (MC = ',') then Goto Loop1;
	if (MC = ';') then Goto Loop;
	if Param and (MC = ')') then Exit;
	Err(21);
end;

{****************************************************************************}
{ Procedura jako pierwsza w liscie. }

Procedure PFToFront(Nm: String);
label
	Loop;
var
	V,P: ^PrFuRec;
begin
	V := PrFuList;
	if (V^.Name = Nm) then Exit;
Loop:
	P := V;
	V := V^.Next;
	if (V^.Name = Nm) then begin
		P^.Next := V^.Next;
		V^.Next := PrFuList;
		PrFuList := V;
		Exit;
		end;
	Goto Loop;
end;

Procedure CompType;
label
	Loop,Skok1,LoopR1,LoopR2,RecEnd;
var
	TName,AName: String[20];
	i: byte;

	Procedure FlushOV;
	label
		Loop;
	begin
	Loop:
		OV := OVL;
		if (OV = NIL) then Exit;
		OVL := OV^.Next;
		Dispose(OV);
		Goto Loop;
	end;

begin
Loop:
	if (Get <> gtIdent) then Err(9);
	INr := FindI;
	if (INr <> 0) then Exit;
	if AskType(Ident) then Err(15);
	TName := Ident;
	MustChar('=');
	if (Get <> gtIdent) then Err(107);
	case FindI of
		{ Nazwa typu }
		0: begin
			if Not(AskType(Ident)) then Err(17);
			GetType(Ident,False,TypeVar);
			AddType(TName,stndNew,defCopy,0,0,NIL,Ident,TypeVar.Even);
			MustChar(';');
			Goto Loop;
			end;
		{ PTR }
		10: begin
			if (Get <> gtIdent) then Err(109);
			{if Not(AskType(Ident)) then Err(17);}
			AddType(TName,stndNew,defPtr,4,0,NIL,Ident,1);
			MustChar(';');
			Goto Loop;
			end;
		{ ARRAY }
		8: begin
			if (Get <> gtIdent) then Err(16);
			if Not(AskType(Ident)) then Err(17);
			AName := Ident;
			MustChar('[');
			i := 1;
		Skok1:
			if (i = 11) then Err(20);
			if (Get <> gtValue) then Err(18);
			AryWTab[i] := Value;
			Inc(i);
			if (Get <> gtZnak) then Err(19);
			if (Ident = ',') then Goto Skok1;
			if (Ident <> ']') then Err(19);
			MustChar(';');
			AddType(TName,stndNew,defAry,0,i-1,NIL,AName,0);
			Goto Loop;
			end;
		{ RECORD }
		9: begin
			Ofs := 0;
			OVL := NIL;
			i := 1;
		LoopR2:
			if (Get <> gtIdent) then Err(108);
			if (Ident = 'END') then Goto RecEnd;
			if Not(AskType(Ident)) then Err(17);
			GetType(Ident,False,TypeVar);
			TSize := TypeVar.MemSize;
			AName := Ident;
		LoopR1:
			if (Get <> gtIdent) then Err(110);
			Inc(i);
			OV := New(OneRecSize);
			if (OV = NIL) then Err(14);
			if (TypeVar.Even = 1) then EEven(Ofs);
			OV^.Next := OVL;
			OVL := OV;
			OV^.Offset := Ofs;
			OV^.Name := Ident;
			OV^.TName := AName;
			Ofs := Ofs+TSize;
			if (Get <> gtZnak) then Err(21);
			if (Ident = ',') then Goto LoopR1;
			if (Ident <> ';') then Err(21);
			{ check end }
			Goto LoopR2;
		RecEnd:
			if (i = 1) then Err(22);
			EEven(Ofs);
			RecMemSize := Ofs;
			AddType(TName,stndNew,defRec,0,i-1,OVL,'',1);
			MustChar(';');
			Goto Loop;
			end;
		end;
	Err(17);
end;

Procedure MuluNat(V: LongInt; RNum: Byte);
var
	dt: String[2];
begin
	Str(RNum,HTxt);
	dt := 'd'+HTxt;
	if (V = 1) then Exit;
	case V of
	2,4,8,16,32,64,128,256,512,1024,2048,4096,8192,16384: begin
		Put(#9#9'lsl.w'#9'#');
		case V of
			2: Put('1');
			4: Put('2');
			8: Put('3');
			16: Put('4');
			32: Put('5');
			64: Put('6');
			128: Put('7');
			256,512,1024,2048,4096,8192,16384: Put('8');
			end;
		Put(',');
		PutL(dt);
		case V of
			2,4,8,16,32,64,128,256: Exit;
			end;
		Put(#9#9'lsl.w'#9'#');
		case V of
			512: Put('1');
			1024: Put('2');
			2048: Put('3');
			4096: Put('4');
			8192: Put('5');
			16384: Put('6');
			end;
		Put(',');
		PutL(dt);
		Exit;
		end;
	end;
	Put(#9#9'mulu.w'#9'#');
	Str(V,HTxt);
	Put(HTxt);
	Put(',');
	PutL(dt);
end;

Procedure AddBreak(Nm: LongInt);
var
	BV: ^BreakType;
begin
	BV := New(BreakRecSize);
	if (BV = NIL) then Err(14);
	BV^.Next := BreakList;
	BreakList := BV;
	BV^.Numer := Nm;
end;

Procedure RemBreak;
var
	BV: ^BreakType;
begin
	BV := BreakList;
	BreakList := BV^.Next;
	Dispose(BV);
end;

Procedure SetBreak(Nm: Byte);
label
	Loop;
var
	BV: ^BreakType;
begin
	BV := BreakList;
Loop:
	if (BV = NIL) then Err(88);
	Dec(Nm);
	if (Nm = 0) then begin
		PutBRA2(BV^.Numer);
		Exit;
		end;
	BV := BV^.Next;
	Goto Loop;
end;

{****************************************************************************}
{ Kompilacja przypisania. }

Function Let(a,b: LongInt; d: Byte): LongInt;
begin
	case d of
		0: Let := a+b;
		1: Let := a-b;
		2: Let := a*b;
		3: Let := a div b;
		4: Let := a mod b;
		5: Let := a shl b;
		6: Let := a shr b;
		7: Let := a and b;
		8: Let := a or b;
		9: Let := 0; { Chwilowo nieczynna !! }
		10: if (a<>0) and (b<>0) then Let := 1
			else Let := 0;
		11: if (a<>0) or (b<>0) then Let := 1
			else Let := 0;
		12: if (a=b) then Let := 1
			else Let := 0;
		13: if (a<>b) then Let := 1
			else Let := 0;
		14: if (a<=b) then Let := 1
			else Let := 0;
		15: if (a>=b) then Let := 1
			else Let := 0;
		16: if (a>b) then Let := 1
			else Let := 0;
		17: if (a<b) then Let := 1
			else Let := 0;
		end;
end;

	{ *** Tworzenie listy skladnikow z GET. *** }
	Function MakeMathList(typ: Byte; spec: Boolean; txt: string; Skip: Boolean): Pointer;
	label
		SkipJ,Petla,Loop,Quit;
	var
		NawCnt,CCnt: Byte;
		C: Char;
		MList: Pointer;
		MVar: ^MRec;

		{ *** Dodanie elementu. *** }
		Procedure AddMath;
		label
			Loop;
		var
			MV: ^MRec;
		begin
			MVar := New(MRecSize);
			if (MVar = NIL) then Err(14);
			MVar^.Next := NIL;
			if (MList = NIL) then
				MList := MVar
			else begin
				MV := MList;
		Loop:
				if (MV^.Next <> NIL) then begin
					MV := MV^.Next;
					Goto Loop;
					end;
				MV^.Next := MVar;
				end;
			MVar^.Typ := INr;
			case INr of
				gtZnak: MVar^.Name := Ident;
				gtIdent: MVar^.Name := Ident;
				gtValue: MVar^.Value := Value;
				gtSpec: MVar^.Value := GVar;
				end;
		end;

	begin
		MList := NIL;
		NawCnt := 0;
		SpecDzial := 0;
		if Spec then begin
			INr := gtValue;
			Goto SkipJ;
			end;
		if Skip then begin
			INr := gtIdent;
			Goto SkipJ;
			end;
	Petla:
		INr := Get;
	SkipJ:
		if (INr = gtZnak) and (Ident = '"') then begin
			HTxt := '';
			CCnt := 0;
		Loop:
			C := GetC;
			if (Ord(C) = 0) then Err(6);
			if (CCnt = 255) then Err(74);
			if (C <> '"') then begin
				HTxt := HTxt+C;
				Inc(CCnt);
				Goto Loop;
				end;
			AddStr(HTxt);
			INr := gtZnak;
			Ident := '@';
			AddMath;
			INr := gtIdent;
			Ident := '_Str_';
			if UnitStat then
				Ident := Ident+UnitFN+'_';
			Str(StringCnt-1,HTxt);
			Ident := Ident+HTxt;
			AddMath;
			Goto Petla;
			end;
		if (INr = gtZnak) and Spec and ((Ident = ',') or (Ident = ':')) then
			Goto Quit;
		if (INr = typ) and (NawCnt = 0) then case typ of
			gtZnak,gtIdent: if (Ident = txt) then Goto Quit;
			end;
		if (INr = gtZnak) then begin
			if (Ident = '(') or (Ident = '[') then begin
				if (NawCnt = 255) then Err(34);
				Inc(NawCnt);
				end;
			if (Ident = ')') or (Ident = ']') then begin
				if (NawCnt = 0) then Err(35);
				Dec(NawCnt);
				end;
			end;
		if (INr = gtSpec) then
			if (GVar >= 8) and (GVar <= 11) then begin
				SpecDzial := GVar;
				GVar := 1;
				end;
		case INr of
			gtEOF: Err(6);
			gtEtyk: Err(32);
			gtZnak: AddMath;
			gtIdent: AddMath;
			gtValue: AddMath;
			gtSpec: AddMath;
			end;
		Goto Petla;
	Quit:
		MakeMathList := MList;
	end;

	{ *** Rozpoznanie zmiennych, f-kcji, stalych, dzialan,... *** }
	Procedure DecodeMath(MList: Pointer; var DList,Source: Pointer);
	label
		Loop,Next,NextLoop,Dzialanie,Identyf,Identyf0,Retry1,Retry2;
	var
		Poz,DzialNum: Byte;
		SetSrc,Minus,Adres,Rozmiar: Boolean;
		WList: Pointer;
		WVar: ^WRec;
		DVar: ^DRec;
		MVar: ^MRec;
		DzialPri: LongInt;
		PFVar: PrFuRec;

		Procedure AddMath;
		label
			Loop,Jump;
		var
			DV: ^DRec;
			WV: ^WRec;
		begin
			WV := WList;
		Jump:
			if (WV <> NIL) then begin
				WV^.IlSklad := WV^.IlSklad+1;
				WV := WV^.Next;
				Goto Jump;
				end;
			DVar := New(DRecSize);
			if (DVar = NIL) then Err(14);
			if SetSrc then begin
				if (Source <> NIL) then Err(37);
				Source := DVar;
				SetSrc := False;
				end;
			DVar^.Next := NIL;
			if (DList = NIL) then
				DList := DVar
			else begin
				DV := DList;
		Loop:
				if (DV^.Next <> NIL) then begin
					DV := DV^.Next;
					Goto Loop;
					end;
				DV^.Next := DVar;
				end;
			DVar^.Poziom := Poz;
		end;

		Procedure Er(Num: Byte);
		label
			Loop;
		begin
		Loop:
			WVar := WList;
			if (WVar = NIL) then begin
				if (Num > 0) then Err(Num);
				Exit;
				end;
			WList := WVar^.Next;
			Dispose(WVar);
			Goto Loop;
		end;

		Procedure AddW;
		begin
			Inc(Poz);
			WVar := New(WRecSize);
			if (WVar = NIL) then Er(14);
			WVar^.Next := WList;
			WList := WVar;
			WVar^.IlNaw := 0;
			WVar^.DPtr := NIL;
		end;

		Procedure RemW;
		begin
			WList := WVar^.Next;
			Dispose(WVar);
			Dec(Poz);
			WVar := WList;
		end;


		Procedure FindDzial;
		var
			dp: Byte;
		begin
			DzialNum := 255;
			DzialPri := 0;
			if (MVar^.typ = gtZnak) then
				with MVar^ do begin
					if (Name = '+') then begin	DzialNum := 0;	dp := 6;	end;
					if (Name = '-') then begin	DzialNum := 1;	dp := 6;	end;
					if (Name = '*') then begin	DzialNum := 2;	dp := 7;	end;
					if (Name = '/') then begin	DzialNum := 3;	dp := 7;	end;
					if (Name = '&') then begin	DzialNum := 7;	dp := 5;	end;
					if (Name = '|') then begin	DzialNum := 8;	dp := 4;	end;
					if (Name = '=') then begin	DzialNum := 12;	dp := 3;	end;
					if (Name = '>') then begin	DzialNum := 16;	dp := 3;	end;
					if (Name = '<') then begin	DzialNum := 17;	dp := 3;	end;
					if (Name = ',') then begin	DzialNum := 254;	dp := 0;	end;
					end;
			if (MVar^.typ = gtSpec) then
				case MVar^.Value of
					2: begin	DzialNum := 13;	dp := 3;	end;
					3: begin	DzialNum := 15;	dp := 3;	end;
					4: begin	DzialNum := 14;	dp := 3;	end;
					5: begin	DzialNum := 4;	dp := 7;	end;
					6: begin	DzialNum := 5;	dp := 7;	end;
					7: begin	DzialNum := 6;	dp := 7;	end;
					end;
			if (MVar^.typ = gtIdent) then begin
				if (MVar^.Name = 'AND') then begin
					DzialNum := 10;
					dp := 2;
					end;
				if (MVar^.Name = 'OR') then begin
					DzialNum := 11;
					dp := 1;
					end;
				end;
			DzialPri := MaxPri*WVar^.IlNaw+dp;
		end;

		Procedure CheckEnd;
		begin
			if (Poz = 1) and (WVar^.IlNaw = 0) then begin
				Er(0);
				Exit;
				end
			else
				Er(6);
		end;

		Procedure NextM;
		begin
			MVar := MVar^.Next;
		end;

		Procedure SetIlSklad;
		begin
			if (WVar^.DPtr <> NIL) then begin
				DVar := WVar^.DPtr;
				DVar^.Ilosc := WVar^.IlSklad;
				WVar^.DPtr := NIL;
				end;
		end;

						{ *** BEGIN DecodeMath *** }
	begin
		Poz := 0;
		SetSrc := False;
		Source := NIL;
		DList := NIL;
		WList := NIL;
		AddW;
		WVar^.typ := wtNone;
		MVar := MList;
	NextLoop:
		Minus := False;
		Adres := False;
		Rozmiar := False;
	Loop:
		if (MVar = NIL) then begin
			CheckEnd;
			Exit;
			end;
		if (MVar^.typ = gtZnak) and (MVar^.Name = '(') then begin
			if (WVar^.IlNaw = 255) then Er(34);
			WVar^.IlNaw := WVar^.IlNaw+1;
			Goto Next;
			end;
		if (MVar^.typ = gtZnak) and (MVar^.Name = '-') then begin
			if Minus then Er(38);
			Minus := True;
			AddMath;
			DVar^.typ := dtConst;
			DVar^.Value := -1;
			AddMath;
			DVar^.typ := dtDzial;
			DVar^.dzial := 2;
			DVar^.Pri := MaxPri*WVar^.IlNaw+3;
			Goto Next;
			end;
		if (MVar^.typ = gtZnak) and (MVar^.Name = '@') then begin
			if Adres or Rozmiar then Er(39);
			Adres := True;
			NextM;
			Goto Identyf0;
			end;
		if (MVar^.typ = gtZnak) and (MVar^.Name = '~') then begin
			if Adres or Rozmiar then Er(39);
			Rozmiar := True;
			NextM;
			Goto Identyf0;
			end;
		if (MVar^.typ = gtIdent) then Goto Identyf0;
		if (MVar^.typ = gtValue) then begin
			AddMath;
			DVar^.typ := dtConst;
			DVar^.Value := MVar^.Value;
			NextM;
			Goto Dzialanie;
			end;
		Er(40);
	Identyf0:
		WVar^.Stat := True;
	Identyf:
		if (MVar^.typ <> gtIdent) then Er(40);
		AddMath;
		DVar^.typ := dtVar;
		if Not(WVar^.Stat) then DVar^.typ := dtPole;
		if Adres then DVar^.typ := dtVarPtr;
		if Rozmiar then DVar^.typ := dtVarSize;
		if WVar^.Stat then
			if GetPrFu(MVar^.Name,PFVar) then
					if Rozmiar then Er(41)
				else
					if Adres then DVar^.typ := dtPFPtr
				else begin
					if Not(PFVar.FuStat) then Err(58);
					DVar^.typ := dtFunc;
					end;
		Adres := False;
		Rozmiar := False;
		if WVar^.Stat then begin
			WVar^.IlSklad := 0;
			WVar^.DPtr := DVar;
			DVar^.Ilosc := 0;
			DVar^.PtrCnt := 0;
			WVar^.Stat := False;
			end;
		DVar^.Start := MVar;
		if (MVar^.Name = 'NOT') then begin
			NextM;
			if (MVar = NIL) then Err(73);
			if (MVar^.typ <> gtZnak) then Err(73);
			if (MVar^.Name <> '(') then Err(73);
			NextM;
			AddMath;
			DVar^.typ := dtDzial;
			DVar^.dzial := 253;
			DVar^.Pri := MaxPri*WVar^.IlNaw+8;
			WVar^.IlNaw := WVar^.IlNaw+1;
			Goto NextLoop;
			end;
		NextM;
		if (MVar = NIL) then begin
			SetIlSklad;
			CheckEnd;
			Exit;
			end;
		case DVar^.typ of
			dtFunc:	if (MVar^.typ = gtZnak) and (MVar^.Name = '(') then begin
						AddW;
						WVar^.typ := wtFunc;
						NextM;
						Goto NextLoop;
						end
					else
						Goto Dzialanie;
			dtPFPtr: Goto Dzialanie;
			end;
		if (MVar^.typ = gtZnak) and (MVar^.Name = '[') then begin
			AddW;
			WVar^.typ := wtAry;
			NextM;
			Goto NextLoop;
			end;
	Retry1:
		if (MVar^.typ = gtZnak) and (MVar^.Name = '.') then begin
			NextM;
			Goto Identyf;
			end;
		if (MVar^.typ = gtZnak) and (MVar^.Name = '^') then begin
			AddMath;
			DVar^.typ := dtPtr;
			NextM;
			Goto Retry1;
			end;
		SetIlSklad;
	Dzialanie:
		if (MVar = NIL) then begin
			CheckEnd;
			Exit;
			end;
		if (MVar^.typ = gtSpec) and (MVar^.Value = 1) then begin
			AddMath;
			DVar^.typ := dtLet;
			SetSrc := True;
			Goto Next;
		end;
		if (MVar^.typ = gtZnak) then
			if (MVar^.Name = ')') then begin
				if (WVar^.IlNaw > 0) then begin
					WVar^.IlNaw := WVar^.IlNaw-1;
					NextM;
					Goto Dzialanie;
					end
				else begin
					if (WVar^.typ <> wtFunc) then Er(46);
					RemW;
					SetIlSklad;
					NextM;
					Goto Dzialanie;
					end;
				end
			else
			if (MVar^.Name = ']') then begin
				if (WVar^.typ <> wtAry) then Er(47);
				RemW;
				NextM;
		Retry2:
				if (MVar^.typ = gtZnak) and (MVar^.Name = '.') then begin
					NextM;
					Goto Identyf;
					end;
				if (MVar^.typ = gtZnak) and (MVar^.Name = '^') then begin
					AddMath;
					DVar^.typ := dtPtr;
					NextM;
					Goto Retry2;
					end;
				SetIlSklad;
				Goto Dzialanie;
				end;
		if (MVar^.typ = gtValue) and (MVar^.Value < 0) then begin
			AddMath;
			DVar^.typ := dtDzial;
			DVar^.dzial := 1;
			DVar^.Pri := MaxPri*WVar^.IlNaw+6;
			AddMath;
			DVar^.typ := dtConst;
			DVar^.Value := -MVar^.Value;
			NextM;
			Goto Dzialanie;
			end;
		FindDzial;
		if (DzialNum = 255) then Err(43);
		AddMath;
		DVar^.typ := dtDzial;
		DVar^.dzial := DzialNum;
		DVar^.Pri := DzialPri;
		NextM;
		Goto NextLoop;
	Next:
		NextM;
		Goto Loop;
	end;

{****************************************************************************}
				{ Kompilacja bloku instrukcji - REKURENCJA. }
{****************************************************************************}


Procedure CompBlock(Retry,EndBegin: Boolean);
label
	Loop,Next,CheckLET,RetryIF,CaseLoop,CaseNext,Next2;
var
	PFVar: PrFuRec;
	MList,DList,Source,M1Mem,M2Mem: Pointer;
	MVar: ^MRec;
	DVar: ^DRec;
	Jmp1,Jmp2,Jmp0: LongInt;
	SD1Mem,SD2Mem,RetIF,UsedD,UsedA,typ: Byte;
	Result: CompRec;
	Out: String[20];
	InD,SetCase: Boolean;
	MemC: Char;
	ONPVar: ^ONPRec;

	{ *** Usuniecie list ONP. *** }
	Procedure RemMDList;
	label
		Loop,Loop2;
	begin
	Loop:
		MVar := MList;
		if (MVar = NIL) then Goto Loop2;
		MList := MVar^.Next;
		Dispose(MVar);
		Goto Loop;
	Loop2:
		DVar := DList;
		if (DVar = NIL) then Exit;
		DList := DVar^.Next;
		Dispose(DVar);
		Goto Loop2;
	end;

	{ *** Usuniecie listy wynikowej ONP. *** }
	Procedure RemONP(Ptr: Pointer);
	label
		Loop;
	begin
	Loop:
		ONPVar := Ptr;
		if (ONPVar = NIL) then Exit;
		Ptr := ONPVar^.Next;
		Dispose(ONPVar);
		Goto Loop;
	end;

	{ *** Tlumaczenie wyrazenia za pomoca Odwrotnej Notacji Polskiej *** }
	Procedure ONP(ptr: Pointer;  var Dest: Pointer);
	label
		MainLoop,Retry;
	var
		Stack: Pointer;
		StackV: ^StackRec;
		HDV: ^DRec;
		poz: Byte;

		{ *** Nastepny rozpoznany skladnik. *** }
		Procedure Next;
		begin
			DVar := DVar^.Next;
		end;

		{ *** Pominiecie opisu dostepu do zmiennej. *** }
		Procedure Skip;
		var
			a,b: Byte;
		begin
			b := DVar^.Ilosc;
			for a := 0 to b do
				Next;
		end;

		{ *** Usuniecie calego stosu pierwotnego ONP. *** }
		Procedure RemStack;
		label
			Loop;
		begin
		Loop:
			StackV := Stack;
			if (StackV = NIL) then Exit;
			Stack := StackV^.Next;
			Dispose(StackV);
			Goto Loop;
		end;

		{ *** Dodanie skladnika ONP. *** }
		Procedure AddONP;
		label
			Loop;
		var
			OV: ^ONPRec;
		begin
			ONPVar := New(ONPRecSize);
			if (ONPVar = NIL) then Err(14);
			ONPVar^.Sklad := DVar;
			ONPVar^.Oper := False;
			if (DVar^.typ = dtDzial) then
				ONPVar^.Oper := True;
			ONPVar^.Next := NIL;
			OV := Dest;
			if (OV = NIL) then
				Dest := ONPVar
			else begin
		Loop:
				if (OV^.Next <> NIL) then begin
					OV := OV^.Next;
					Goto Loop;
					end;
				OV^.Next := ONPVar;
				end;
		end;

		Procedure AddStack;
		begin
			StackV := New(StackRecSize);
			if (StackV = NIL) then Err(14);
			StackV^.Next := Stack;
			Stack := StackV;
			StackV^.Sklad := DVar;
		end;

		Procedure GetStack;
		var
			DV: Pointer;
			SV: ^StackRec;
		begin
			SV := Stack;
			Stack := SV^.Next;
			StackV := Stack;
			DV := DVar;
			DVar := SV^.Sklad;
			Dispose(SV);
			AddONP;
			DVar := DV;
		end;

		{ *** Oproznienie stosu ONP. *** }
		Procedure FlushStack;
		label
			Loop;
		begin
		Loop:
			if (Stack = NIL) then Exit;
			GetStack;
			Goto Loop;
		end;

	begin
		Dest := NIL;
		Stack := NIL;
		DVar := ptr;
		poz := DVar^.Poziom;
	MainLoop:
		if (DVar = NIL) then begin
			FlushStack;
			Exit;
			end;
		if (DVar^.Poziom < poz) then begin
			FlushStack;
			Exit;
			end;
		if (DVar^.typ = dtLet) then begin
			FlushStack;
			Exit;
			end;
		if (DVar^.typ = dtDzial) and (DVar^.Dzial = 254) then begin
			FlushStack;
			Exit;
			end;
		if (DVar^.typ <> dtDzial) then begin
			AddONP;
			case DVar^.typ of
				dtVar: Skip;
				dtFunc: Skip;
				dtVarPtr: Skip;
				dtPFPtr: Next;
				dtVarSize: Skip;
				dtConst: Next;
				end;
			Goto MainLoop;
			end;
	Retry:
		if (Stack = NIL) then begin
			AddStack;
			Next;
			Goto MainLoop;
			end;
		HDV := StackV^.Sklad;
		if (HDV^.Pri < DVar^.Pri) then begin
			AddStack;
			Next;
			Goto MainLoop;
			end;
		GetStack;
		Goto Retry;
	end;

	{****************************************************************************}
	{ Pobranie typu funkcji. }

	Function GetFType(ptr: Pointer): Byte;
	var
		DV: ^DRec;
		MV: ^MRec;
		PF: PrFuRec;
		VR: TypeRec;
	begin
		DV := ptr;
		MV := DV^.Start;
		if Not(GetPrFu(MV^.Name,PF)) then Err(43);
		GetType(PF.FTName,True,VR);
		GetFType := VR.stndTyp;
	end;

	{****************************************************************************}
	{ Pobranie typu zmiennej. }

	Function GetVType(ptr: Pointer): Byte;
	label
		Next,Loop;
	var
		VNm,TNm,PNm: String[20];
		DV: ^DRec;
		MV: ^MRec;
		Il,tp,poz: Byte;

		Procedure NextD;
		begin
			DV := DV^.Next;
			Dec(Il);
		end;

		Procedure SkipAryParam;
		label
			Loop;
		var
			h: pointer;
		begin
		Loop:
			h := DV;
			NextD;
			if (DV^.Poziom = poz) then begin
				Inc(il);
				DV := h;
				Exit;
				end;
			if (il = 0) then Exit;
			Goto Loop;
		end;

		Procedure FindPole;
		label
			Loop;
		var
			OV: ^OneRec;
		begin
			OV := TypeVar.RecList;
		Loop:
			if (OV = NIL) then Err(55);
			if (OV^.Name = PNm) then begin
				TNm := OV^.TName;
				Exit;
				end;
			OV := OV^.Next;
			Goto Loop;
		end;

	begin
		DV := ptr;
		poz := DV^.Poziom;
		MV := DV^.Start;
		VNm := MV^.Name;
		if (VNm = 'NOT') then begin
			GetVType := 0;
			Exit;
			end;
		Il := DV^.Ilosc;
		if Not(AskVar(VNm,HlpB)) then Err(50);
		FindVType(VNm,TypeVar);
	Loop:
		tp := TypeVar.StndTyp;
		if (TypeVar.StndTyp = StndNew) and (TypeVar.DefTyp = DefPtr) then
			tp := StndLong;
		if (Il = 0) then begin
			GetVType := tp;
			Exit;
			end;
		NextD;
		if (DV^.typ = dtPtr) then
			if ((TypeVar.StndTyp = StndNew) and (TypeVar.DefTyp = defPtr))
				or (TypeVar.StndTyp = StndLong) then begin
				TNm := TypeVar.AParent;
				GetType(TNm,True,TypeVar);
				Goto Loop;
				end
			else
				Err(52);
		if (DV^.typ = dtPole) then
			if (TypeVar.StndTyp = StndNew) and (TypeVar.DefTyp = defRec) then begin
				MV := DV^.Start;
				PNm := MV^.Name;
				FindPole;
				GetType(TNm,True,TypeVar);
				Goto Loop;
				end
			else
				Err(53);
		if (DV^.Poziom <> poz) then
			if (TypeVar.StndTyp = StndNew) and (TypeVar.DefTyp = defAry) then begin
				SkipAryParam;
				TNm := TypeVar.AParent;
				GetType(TNm,True,TypeVar);
				Goto Loop;
				end
			else
				Err(54);
		Err(49);
	end;

	Procedure CompInt(ptr: Pointer;  typ: Byte;  var Result: CompRec);
	FORWARD;

	Procedure CompD(Only,NoChg: Boolean; ptr: Pointer;  TNum: byte;  var UsedD,UsedA: Byte;
	  var Out: String;  var InD,aePC: Boolean);
	FORWARD;

	{ *** Kompilacja parametrow Proc., Func. *** }
	Procedure CompPFParam(ptr: Pointer;  Nm: String);
	label
		Jump1;
	var
		DV: ^DRec;
		MV: ^MRec;
		PFV: PrFuRec;
		PV: ^ParamRec;
		st1,st2,il,i,typ: Byte;
		TV: TypeRec;
		ofs,si,JMem: LongInt;
		DCnt,ASrc,ADst: Byte;
		OutTxt: String[20];
		InD: Boolean;
		Result: CompRec;

		Procedure NextParam;
		label
			Loop;
		var
			Poz: Byte;
		begin
			Poz := DV^.Poziom;
		Loop:
			DV := DV^.Next;
			if (DV = NIL) then Err(75);
			if (DV^.typ = dtDzial) and (DV^.Poziom = poz) and (DV^.Dzial = 254) then begin
				DV := DV^.Next;
				if (DV = NIL) then Err(98);
				Exit;
				end;
			Goto Loop;
		end;

	begin
		if Not(GetPrFu(Nm,PFV)) then Err(96);
		il := PFV.IlP;
		DV := ptr;
		PV := PFV.PList;
		Put(#9#9'lea'#9'-');
		Str(PFV.StackPar,HTxt);
		Put(HTxt);
		PutL('(sp),sp');
		if PFV.FuStat then
			ofs := 4
		else
			ofs := 0;
		for i := 1 to il do begin
			if (PV = NIL) then Err(97);
			if (DV = NIL) then Err(98);
			GetType(PV^.TName,True,TV);
			st1 := TypeToSize(TV.stndTyp);
			if (TV.stndTyp <> stndNew) then begin
				if (PV^.PoVar) then begin
					st2 := GetVType(DV);
					st2 := TypeToSize(st2);
					if (st1 <> st2) then Err(110);
					CompD(True,True,DV,0,DCnt,ASrc,OutTxt,InD,HlpB);
					if ((ofs and 1) = 1) then
						Inc(ofs);
					if (DCnt <> 255) then
						FreeReg(True,DCnt);
					Put(#9#9'move.l'#9'a');
					Str(ASrc,HTxt);
					Put(HTxt);
					Put(',');
					Str(ofs,HTxt);
					Put(HTxt);
					PutL('(sp)');
					FreeReg(False,ASrc);
					Inc(ofs,4);
					end
				else begin
					CompInt(DV,TV.stndTyp,Result);
					if (st1 = siWord) or (st1 = siLong) then
						if ((ofs and 1) = 1) then
							Inc(ofs);
					case Result.ctTyp of
						ctConst: begin
							Str(Result.ValNum,HTxt);
							Put(#9#9'move.');
							case st1 of
								siByte: Put('b');
								siWord: Put('w');
								siLong: Put('l');
								end;
							Put(#9'#');
							Put(HTxt);
							Put(',');
							Str(ofs,HTxt);
							Put(HTxt);
							PutL('(sp)');
							end;
						ctReg: begin
							Put(#9#9'move.');
							case st1 of
								siByte: Put('b');
								siWord: Put('w');
								siLong: Put('l');
								end;
							Put(#9'd');
							Str(Result.ValNum,HTxt);
							Put(HTxt);
							Put(',');
							Str(ofs,HTxt);
							Put(HTxt);
							PutL('(sp)');
							FreeReg(True,Result.ValNum);
							end;
						ctDVar: begin
							CompD(False,False,Result.DPtr,TV.stndTyp,DCnt,ASrc,OutTxt,InD,HlpB);
							if InD then begin
								Put(#9#9'move.');
								case st1 of
									siByte: Put('b');
									siWord: Put('w');
									siLong: Put('l');
									end;
								Put(#9'd');
								Str(DCnt,HTxt);
								Put(HTxt);
								Put(',');
								Str(ofs,HTxt);
								Put(HTxt);
								PutL('(sp)');
								end
							else begin
								Put(#9#9'move.');
								case st1 of
									siByte: Put('b');
									siWord: Put('w');
									siLong: Put('l');
									end;
								Put(#9);
								Put(OutTxt);
								Put(',');
								Str(ofs,HTxt);
								Put(HTxt);
								PutL('(sp)');
								end;
							if (DCnt <> 255) then
								FreeReg(True,DCnt);
							if (ASrc <> 255) then
								FreeReg(False,ASrc);
							end;
						end;
					case st1 of
						siByte: Inc(ofs);
						siWord: Inc(ofs,2);
						siLong: Inc(ofs,4);
						end;
					end;
				end
			else begin
				if (GetVType(DV) <> stndNew) then Err(94);
				if (TypeVar.Name <> TV.Name) then Err(95);
				CompD(True,True,DV,0,DCnt,ASrc,OutTxt,InD,HlpB);
				if (PV^.PoVar) then begin
					if (DCnt <> 255) then
						FreeReg(True,DCnt);
					FreeReg(False,ASrc);
					if ((ofs and 1) = 1) then
						Inc(ofs);
					Put(#9#9'move.l'#9'a');
					Str(ASrc,HTxt);
					Put(HTxt);
					Put(',');
					Str(ofs,HTxt);
					Put(HTxt);
					PutL('(sp)');
					Inc(ofs,4);
					Goto Jump1;
					end;
				si := TV.MemSize-1;
				if (DCnt = 255) then
					DCnt := AllocReg(True,siWord);
				ADst := AllocReg(False,0);
				if (si < 128) then
					Put(#9#9'moveq'#9'#')
				else
					Put(#9#9'move.w'#9'#');
				Str(si,HTxt);
				Put(HTxt);
				Put(',d');
				Str(DCnt,HTxt);
				PutL(HTxt);
				Put(#9#9'lea'#9);
				if (TypeVar.Even = 1) then
					if ((ofs and 1) = 1) then
						Inc(ofs);
				Str(ofs,HTxt);
				Put(HTxt);
				Put('(sp),a');
				Str(ADst,HTxt);
				PutL(HTxt);
				JMem := JumpCnt;
				SetJump;
				Put(#9#9'move.b'#9'(a');
				Str(ASrc,HTxt);
				Put(HTxt);
				Put(')+,(a');
				Str(ADst,HTxt);
				Put(HTxt);
				PutL(')+');
				Put(#9#9'dbf'#9'd');
				Str(DCnt,HTxt);
				Put(HTxt);
				Put(',_');
				if UnitStat then begin
					Put(UnitFN);
					Put('_');
					end;
				Str(JMem,HTxt);
				PutL(HTxt);

				FreeReg(True,DCnt);
				FreeReg(False,ADst);
				ofs := ofs+si;
				end;
		Jump1:
			if (i <> il) then NextParam;
			PV := PV^.Next;
			end;
	end;

	{ *** Kompilacja dostepu do zmiennej lub funkcji. *** }
	Procedure CompD(Only,NoChg: Boolean; ptr: Pointer;  TNum: byte;  var UsedD,UsedA: Byte;
	  var Out: String;  var InD,aePC: Boolean);
	label
		SkipLea;
	var
		DV: ^DRec;
		MV: ^MRec;
		Tn,t1,t2: Byte;
		il: Byte;
		dt: String[2];
		NoMustLea: Boolean;

		Procedure CV(NoAdr: Boolean);
		label
			Loop,NextOK,Skok1,Loop2,NextOK2,Skok12;
		var
			VR: VarRec;
			TR: TypeRec;
			OneV: ^OneRec;
			N,DOut: String[20];
			NOfs,Stat,DInD: Boolean;
			ofs: LongInt;
			IlAry,AryCnt,stndTAry: Byte;
			AryMn: LongInt;
			AryTab: array [1..MaxAryTab] of LongInt;
			Result: CompRec;
			Dud,Dua: Byte;

			Procedure AddOfs;
			begin
				if (ofs <> 0) then begin
					Str(ofs,HTxt);
					Out := Out+'+'+HTxt;
					end;
				NOfs := False;
				if Not(NoAdr) then Exit;
				if NoChg then Exit;
				if (t1 = t2) then Exit;
				if (t1=siByte) and (t2=siWord) then begin Out := Out+'+1';  ofs := 1;  end;
				if (t1=siByte) and (t2=siLong) then begin Out := Out+'+3';  ofs := 3;  end;
				if (t1=siWord) and (t2=siLong) then begin Out := Out+'+2';  ofs := 2;  end;
				if (t1=siWord) and (t2=siByte) then NOfs := True;
				if (t1=siLong) and (t2=siByte) then NOfs := True;
				if (t1=siLong) and (t2=siWord) then NOfs := True;
			end;

			Procedure AddNOfs(NewAlloc: Boolean);
			var
				dt: String[2];

				Procedure PutMove;
				begin
					Put(#9#9'move.');
					if (t2=siByte) then
						Put('b')
					else
						Put('w');
					Put(#9);
					Put(Out);
					Put(',');
					PutL(dt);
					if Not(NewAlloc) then begin
						if (t2=siByte) then begin
							Put(#9#9'and.l'#9'#$ff,');
							PutL(dt);
							end
						else begin
							Put(#9#9'and.l'#9'#$ffff,');
							PutL(dt);
							end;
						end;
					Out := dt;
				end;

			begin
				if Not(NOfs) then Exit;
				if NewAlloc then
					UsedD := AllocReg(True,TNum);
				aePC := False;
				InD := True;
				Str(UsedD,HTxt);
				dt := 'd'+Htxt;
				if (t1=siWord) and (t2=siByte) then
					if (TNum=stndUWord) and (Tn=stndUByte) then begin
						PutMove;
						Put(#9#9'ext.w'#9);
						PutL(dt);
						Exit;
						end;
				if (t1=siLong) and (t2=siByte) then
					if (TNum=stndULong) and (Tn=stndUByte) then begin
						PutMove;
						Put(#9#9'ext.w'#9);
						PutL(dt);
						Put(#9#9'ext.l'#9);
						PutL(dt);
						Exit;
						end;
				if (t1=siLong) and (t2=siWord) then
					if (TNum=stndULong) and (Tn=stndUWord) then begin
						PutMove;
						Put(#9#9'ext.l'#9);
						PutL(dt);
						Exit;
						end;
				if NewAlloc then begin
					Put(#9#9'moveq'#9'#0,');
					PutL(dt);
					end;
				PutMove
			end;

			Procedure PrevParam(NewAlloc: Boolean);
			var
				k: Byte;
				Was: Boolean;
			begin
				if NewAlloc then
					UsedA := AllocReg(False,0);
				Str(UsedA,HTxt);
				dt := 'a'+HTxt;
				Was := False;
				for k := VR.Dpth to Depth-1 do begin
					if Was then begin
						Put(#9#9'move.l'#9'8(');
						Put(dt);
						Put('),');
						PutL(dt);
						end
					else begin
						Put(#9#9'move.l'#9'8(a6),');
						PutL(dt);
						end;
					Was := True;
					end;
			end;

			Procedure NextD;
			begin
				Dec(il);
				DV := DV^.Next;
			end;

			Procedure CheckStatic(ptr: Pointer;  il: Byte);
			label
				Loop;
			var
				DV: ^DRec;
			begin
				Stat := True;
				DV := ptr;
			Loop:
				if (il = 0) or Not(Stat) then Exit;
				case DV^.Typ of
					dtVar,dtFunc,dtVarPtr,dtPFPtr,dtPtr: Stat := False;
					end;
				DV := DV^.Next;
				Dec(il);
				Goto Loop;
			end;

			Procedure ToNextPole;
			label
				Loop;
			var
				p: Byte;
			begin
				p := DV^.Poziom;
			Loop:
				NextD;
				if (DV^.Poziom < p) then Err(65);
				if (DV^.Poziom > p) then Goto Loop;
				if (DV^.Typ <> dtDzial) then Goto Loop;
				if (DV^.Dzial <> 254) then Goto Loop;
				NextD;
				if (DV^.Poziom <> p) then Err(65);
			end;

			Procedure ToEndOfAry;
			label
				Loop;
			var
				p: Byte;
			begin
				p := DV^.Poziom;
			Loop:
				if (il = 0) then Exit;
				if (DV^.Typ = dtDzial) and (DV^.Dzial = 254) then Err(66);
				if (DV^.Poziom >= p) then begin
					NextD;
					Goto Loop;
					end;
			end;

		begin
			MV := DV^.Start;
			N := MV^.Name;
			GetVar(N,VR);
			if UnitStat and (VR.Dpth <> 0) then N := N+'_'+UnitFN;	{!!!}
			if (VR.VarOp = opUnk) then begin
				Out := N;
				if Not(opLng) then
					Out := Out+'(pc)';
				Exit;
				end;
			if (VR.Dpth > 0) then
				if Not(VR.AsemVar) then begin
				Str(VR.Cntr,HTxt);
				N := N+'_'+HTxt;
				end;
			GetType(VR.TName,True,TR);
			il := DV^.Ilosc+1;
			ofs := 0;
			NextD;
			CheckStatic(Dv,il);
			if Stat then Goto Loop;
			UsedA := AllocReg(False,0);
			Str(UsedA,HTxt);
			case VR.VarOp of
				opMem: begin
					Put(#9#9'lea'#9);
					Put(N);
					if opLng then
						Put(',a')
					else
						Put('(pc),a');
					PutL(HTxt);
					end;
				opSts,opStsPar:
					if (VR.Dpth = Depth) then begin
						Put(#9#9'lea'#9);
						Put(N);
						Put('(a6),a');
						PutL(HTxt);
						end
					else begin
						PrevParam(False);
						Put(#9#9'lea'#9);
						Put(N);
						Put('(a');
						Put(HTxt);
						Put('),a');
						PutL(HTxt);
						end;
				opAdr: begin
					Put(#9#9'lea'#9);
					Put(N);
					Put(',a');
					PutL(HTxt);
					end;
				opStsPtr:
					if (VR.Dpth = Depth) then begin
						Put(#9#9'move.l'#9);
						Put(N);
						Put('(a6),a');
						PutL(HTxt);
						end
					else begin
						PrevParam(False);
						Put(#9#9'move.l'#9);
						Put(N);
						Put('(a');
						Put(HTxt);
						Put('),a');
						PutL(HTxt);
						end;
				end;
		Loop2:
			if (il = 0) then begin
				Out := '0';
				AddOfs;
				Str(UsedA,HTxt);
				NoMustLea := False;
				if (ofs = 0) and (UsedD = 255) then begin
					Out := '(a'+HTxt+')';
					AddNOfs(True);
					NoMustLea := True;
					Exit;
					end;
				if (UsedD = 255) then begin
					Out := Out+'(a'+HTxt+')';
					AddNOfs(True);
					Exit;
					end;
				if (UsedD <> 255) then begin
					Out := Out+'(a'+HTxt+',d';
					Str(UsedD,HTxt);
					Out := Out+HTxt+'.w)';
					AddNOfs(False);
					Exit;
					end;
				end
			else case DV^.Typ of
				dtPtr: begin
					if (ofs = 0) and (UsedD = 255) then begin
						Str(UsedA,HTxt);
						Put(#9#9'move.l'#9'(a');
						Put(HTxt);
						Put('),a');
						PutL(HTxt);
						end;
					if (ofs <> 0) and (UsedD = 255) then begin
						Put(#9#9'move.l'#9);
						Str(ofs,HTxt);
						Put(HTxt);
						Put('(a');
						Str(UsedA,HTxt);
						Put(HTxt);
						Put('),a');
						PutL(Htxt);
						end;
					if (UsedD <> 255) then begin
						Put(#9#9'move.l'#9);
						Str(ofs,HTxt);
						Put(HTxt);
						Put('(a');
						Str(UsedA,HTxt);
						Put('.d');
						Str(UsedD,HTxt);
						Put(Htxt);
						Put('.w),a');
						Str(UsedA,HTxt);
						PutL(Htxt);
						end;
					ofs := 0;
					aePC := False;
					if (UsedD <> 255) then
						FreeReg(True,UsedD);
					UsedD := 255;
					GetType(TR.AParent,True,TR);
					Goto NextOK2;
					end;
				dtConst,dtVarSize,dtVar,dtFunc,dtVarPtr,dtPFPtr,dtPtr: begin
					if (TR.StndTyp <> stndNew) then Err(61);
					if (TR.DefTyp <> defAry) then Err(61);
					AryMn := TR.MPSize;
					if (TR.MemSize > 65536) then
						stndTAry := stndLong
					else if (TR.MemSize > 256) then
						stndTAry := stndWord
					else
						stndTAry := stndWord;
					for AryCnt := 1 to 10 do
						AryTab[AryCnt] := TR.AryTab[AryCnt];
					IlAry := TR.Pola;
					for AryCnt := 1 to IlAry do begin
						CompInt(DV,stndTAry,Result);
						case Result.ctTyp of
							ctConst: ofs := ofs+Result.ValNum*AryMn;
							ctDVar: begin
								case stndTAry of
									stndWord: begin
										CompD(False,False,Result.DPtr,stndWord,Dud,Dua,DOut,DInD,HlpB);
										if DInD then begin
											if (UsedD = 255) then begin
												UsedD := Dud;
												MuluNat(AryMn,UsedD);
												end
											else begin
												MuluNat(AryMn,Dud);
												Str(Dud,HTxt);
												Put(#9#9'add.w'#9'd');
												Put(HTxt);
												Put(',d');
												Str(UsedD,HTxt);
												PutL(HTxt);
												FreeReg(True,Dud);
												end;
											end
										else begin
											if (UsedD = 255) then begin
												if (Dud <> 255) then
													UsedD := Dud
												else
													UsedD := AllocReg(True,siWord);
												Put(#9#9'move.w'#9);
												Put(DOut);
												Put(',d');
												Str(UsedD,HTxt);
												PutL(HTxt);
												MuluNat(AryMn,UsedD);
												end
											else begin
												if (Dud = 255) then
													Dud := AllocReg(True,siWord);
												Put(#9#9'move.w'#9);
												Put(DOut);
												Put(',d');
												Str(Dud,HTxt);
												PutL(HTxt);
												MuluNat(AryMn,Dud);
												Str(Dud,HTxt);
												Put(#9#9'add.w'#9'd');
												Put(HTxt);
												Put(',d');
												Str(UsedD,HTxt);
												PutL(HTxt);
												FreeReg(True,Dud);
												end;
											end;
										if (Dua <> 255) then FreeReg(False,Dua);
										end;
									stndLong: Err(68);
									end;
								end;
							ctReg: if (UsedD = 255) then begin
									UsedD := Result.ValNum;
									case stndTAry of
										stndWord: begin
											Put(#9#9'mulu.w'#9'#');
											Str(AryMn,HTxt);
											Put(HTxt);
											Put(',d');
											Str(UsedD,HTxt);
											PutL(HTxt);
											end;
										stndLong: Err(68);
										end;
									end
								else begin
									case stndTAry of
										stndWord: begin
											Put(#9#9'mulu.w'#9'#');
											Str(AryMn,HTxt);
											Put(HTxt);
											Put(',d');
											Str(Result.ValNum,HTxt);
											PutL(HTxt);
											Put(#9#9'add.w'#9'd');
											end;
										stndLong: Err(68);
										end;
									Put(HTxt);
									Put(',d');
									Str(UsedD,HTxt);
									PutL(HTxt);
									FreeReg(True,Result.ValNum);
									end;
							end;
						AryMn := AryMn*AryTab[AryCnt];
						if (AryCnt <> IlAry) then ToNextPole;
						end;
					ToEndOfAry;
					GetType(TR.AParent,True,TR);
					Goto Loop2;
					end;
				dtPole: begin
					if (TR.StndTyp <> stndNew) then Err(60);
					if (TR.DefTyp <> defRec) then Err(60);
					OneV := TR.RecList;
					MV := DV^.Start;
				Skok12:
					if (OneV = NIL) then Err(62);
					if (OneV^.Name <> MV^.Name) then begin
						OneV := OneV^.Next;
						Goto Skok12;
						end;
					ofs := ofs+OneV^.Offset;
					GetType(OneV^.TName,True,TR);
					Goto NextOK2;
					end;
				end;
			Err(59);
		NextOK2:
			NextD;
			Goto Loop2;

		Loop:
			if (il = 0) then begin
				case VR.VarOp of
					opMem: begin
						Out := N;
						AddOfs;
						if Not(opLng) then begin
							Out := Out+'(pc)';
							aePC := True;
							end;
						AddNOfs(True);
						end;
					opSts,opStsPar: if (VR.Dpth = Depth) then begin
							Out := N;
							AddOfs;
							Out := Out+'(a6)';
							AddNOfs(True)
							end
						else begin
							PrevParam(True);
							Out := N;
							AddOfs;
							Out := Out+'('+dt+')';
							AddNOfs(True);
							end;
					opAdr: begin
						Out := N;
						AddOfs;
						AddNOfs(True);
						end;
					opStsPtr: if (VR.Dpth = Depth) then begin
							UsedA := AllocReg(False,0);
							Str(UsedA,HTxt);
							dt := 'a'+HTxt;
							Put(#9#9'move.l'#9);
							Put(N);
							Put('(a6),');
							PutL(dt);
							Out := '0';
							AddOfs;
							Out := Out+'('+dt+')';
							AddNOfs(True);
							end
						else begin
							PrevParam(True);
							Put(#9#9'move.l'#9);
							Put(N);
							Put('(');
							Put(dt);
							Put(')');
							Put(',');
							PutL(dt);
							Out := '0';
							AddOfs;
							Out := Out+'('+dt+')';
							AddNOfs(True);
							end;
					end;
				Exit;
				end;
			case DV^.Typ of
				dtConst,dtVarSize: begin
					if (TR.StndTyp <> stndNew) then Err(61);
					if (TR.DefTyp <> defAry) then Err(61);
					AryMn := TR.MPSize;
					if (TR.MemSize > 65536) then
						stndTAry := stndLong
					else if (TR.MemSize > 256) then
						stndTAry := stndWord
					else
						stndTAry := stndByte;
					for AryCnt := 1 to 10 do
						AryTab[AryCnt] := TR.AryTab[AryCnt];
					IlAry := TR.Pola;
					for AryCnt := 1 to IlAry do begin
						CompInt(DV,stndTAry,Result);
						if (Result.ctTyp <> ctConst) then Err(64);
						ofs := ofs+Result.ValNum*AryMn;
						AryMn := AryMn*AryTab[AryCnt];
						if (AryCnt <> IlAry) then ToNextPole;
						end;
					ToEndOfAry;
					GetType(TR.AParent,True,TR);
					Goto Loop;
					end;
				dtPole: begin
					if (TR.StndTyp <> stndNew) then Err(60);
					if (TR.DefTyp <> defRec) then Err(60);
					OneV := TR.RecList;
					MV := DV^.Start;
				Skok1:
					if (OneV = NIL) then Err(62);
					if (OneV^.Name <> MV^.Name) then begin
						OneV := OneV^.Next;
						Goto Skok1;
						end;
					ofs := ofs+OneV^.Offset;
					GetType(OneV^.TName,True,TR);
					Goto NextOK;
					end;
				end;
			Err(59);
		NextOK:
			NextD;
			Goto Loop;
		end;

	var
		MoveM: LongInt;
		ClrDn: Boolean;

	begin
		InD := False;
		aePC := False;
		DV := ptr;
		UsedD := 255;
		UsedA := 255;
		t1 := TypeToSize(TNum);

		if Only then begin
			CV(False);
			if NoMustLea then Exit;
			if (UsedA = 255) then
				UsedA := AllocReg(False,0);
			Put(#9#9'lea'#9);
			Put(Out);
			Put(',a');
			Str(UsedA,HTxt);
			PutL(HTxt);
			Exit;
			end;

		case DV^.typ of

			dtVar: begin
				Tn := GetVType(DV);
				if (Tn = stndNew) then Err(51);
				t2 := TypeToSize(Tn);
				CV(True);
				Exit;
				end;

			dtFunc: begin
				MoveM := PushRegs;
				MV := DV^.Start;
				if Not(GetPrFu(MV^.Name,PFVar)) then Err(69);
				if (Depth = 1) and UnitStat then
					AddPFCall(PFVar);
				if (PFVar.IlP <> 0) then begin
					if (DV^.Next = NIL) then Err(70);
					DV := DV^.Next;
					CompPFParam(DV,MV^.Name);
					end
				else begin
					PutL(#9#9'lea'#9'-4(sp),sp');
					end;
				if (PFVar.Dpth > 0) then begin
					PutL(#9#9'move.l'#9'a6,-(sp)');
					end;
				Str(PFVar.Cntr,HTxt);
				HStr := PFVar.Name;
				if (PFVar.Dpth > 0) then
					if UnitStat then
						HStr := HStr+'_'+UnitFN+'_'+HTxt
					else
						HStr := HStr+'_'+HTxt;
				PutBSR(HStr);
				UsedD := AllocReg(True,stndLong);
				InD := True;
				Str(UsedD,dt);
				Out := 'd'+dt;
				GetType(PFVar.FTName,True,TypeVar);
				ClrDn := False;
				if Not(NoChg) then
					case TNum of
						stndWord: if (TypeVar.stndTyp = stndByte) or
									(TypeVar.stndTyp = stndUByte) then
									ClrDn := True;
						stndLong: if (TypeVar.stndTyp = stndByte) or
									(TypeVar.stndTyp = stndUByte) or
									(TypeVar.stndTyp = stndWord) or
									(TypeVar.stndTyp = stndUWord) then
									ClrDn := True;
						stndUWord: if (TypeVar.stndTyp = stndByte) then
									ClrDn := True;
						stndULong: if (TypeVar.stndTyp = stndByte) or
									(TypeVar.stndTyp = stndWord) then
									ClrDn := True;
						end;
				case TypeToSize(TypeVar.stndTyp) of
					siByte: begin
						if ClrDn then begin
							Put(#9#9'moveq'#9'#0,');
							PutL(Out);
							end;
						Put(#9#9'move.b'#9'(sp),');
						PutL(Out);
						end;
					siWord: begin
						if ClrDn then begin
							Put(#9#9'moveq'#9'#0,');
							PutL(Out);
							end;
						Put(#9#9'move.w'#9'(sp),');
						PutL(Out);
						end;
					siLong: if (PFVar.IlP <> 0) then begin
							Put(#9#9'move.l'#9'(sp),');
							PutL(Out);
							end
						else begin
							Put(#9#9'move.l'#9'(sp)+,');
							PutL(Out);
							Goto SkipLea;
							end;
					end;
				if (PFVar.StackPar > 0) then begin
					Put(#9#9'lea'#9);
					Str(PFVar.StackPar,HTxt);
					Put(HTxt);
					PutL('(sp),sp');
					end;
			SkipLea:
				if (TNum = stndUWord) and (TypeVar.stndTyp = stndUByte) then begin
					Put(#9#9'ext.w'#9);
					PutL(Out);
					end;
				if (TNum = stndULong) and (TypeVar.stndTyp = stndUByte) then begin
					Put(#9#9'ext.w'#9);
					PutL(Out);
					Put(#9#9'ext.l'#9);
					PutL(Out);
					end;
				if (TNum = stndULong) and (TypeVar.stndTyp = stndUWord) then begin
					Put(#9#9'ext.l'#9);
					PutL(Out);
					end;
				PopRegs(MoveM);
				Exit;
				end;

			dtVarPtr: begin
				MV := DV^.Start;
				if (MV^.Name[1] = '_') then begin
					UsedA := AllocReg(False,0);
					FreeReg(False,UsedA);
					Str(UsedA,HTxt);
					Put(#9#9'lea'#9);
					Put(MV^.Name);
					if opLng then
						Put(',a')
					else
						Put('(pc),a');
					PutL(HTxt);
					Put(#9#9'move.l'#9'a');
					Put(HTxt);
					Put(',');
					UsedA := 255;
					UsedD := AllocReg(True,stndLong);
					Str(UsedD,HTxt);
					Out := 'd'+HTxt;
					PutL(Out);
					InD := True;
					Exit;
					end;
				CV(False);
				if ((UsedD) = 255) then
					UsedD := AllocReg(True,stndLong);
				if ((UsedA) = 255) then
					UsedA := AllocReg(False,0);
				Put(#9#9'lea'#9);
				Put(Out);
				Put(',a');
				Str(UsedA,HTxt);
				PutL(HTxt);
				Put(#9#9'move.l'#9'a');
				Put(Htxt);
				Put(',d');
				Str(UsedD,HTxt);
				PutL(HTxt);
				FreeReg(False,UsedA);
				UsedA := 255;
				Out := 'd'+HTxt;
				InD := True;
				Exit;
				end;

			dtPFPtr: begin
				MV := DV^.Start;
				UsedA := AllocReg(False,0);
				Str(UsedA,HTxt);
				Put(#9#9'lea'#9);
				Put(MV^.Name);
				if opLng then
					Put(',a')
				else
					Put('(pc),a');
				PutL(HTxt);
				Out := 'a'+HTxt;
				Exit;
				end;

			end;
		Err(49);
	end;

	{ *** Przeklad listy ONP na asembler. *** }
	Procedure CompONP(ptr: Pointer; TNum: Byte; var CV: CompRec);
	label
		Loop,Next;
	var
		ONPVar: ^ONPRec;
		Stack: Pointer;
		C: ^CompRec;
		C1,C2,C3: CompRec;
		LI: LongInt;
		TNr1,TNr2,TNr3,TNr: Byte;
		NoChg: Boolean;

		Procedure SetS(vl: LongInt;  var Cx: CompRec);
		begin
			if (vl >= 0) and (vl <= 255) then begin
				Cx.ctVTyp := stndByte;
				Exit;
				end;
			if (vl >= -128) and (vl <= 127) then begin
				Cx.ctVTyp := stndUByte;
				Exit;
				end;
			if (vl >= 0) and (vl <= 65535) then begin
				Cx.ctVTyp := stndWord;
				Exit;
				end;
			if (vl >= -32768) and (vl <= 32767) then begin
				Cx.ctVTyp := stndUWord;
				Exit;
				end;
			if (vl >= 0) then begin
				Cx.ctVTyp := stndLong;
				Exit;
				end;
			Cx.ctVTyp := stndULong;
		end;

		Procedure Push;
		begin
			C := New(CompRecSize);
			if (C = NIL) then Err(14);
			C^.Next := Stack;
			Stack := C;
		end;

		Procedure Pop;
		begin
			if (Stack = NIL) then Err(49);
			C := Stack;
			Stack := C^.Next;
			Dispose(C);
			C := Stack;
		end;

		Procedure CompileDzial(D: Byte);
		label
			Skip;
		var
			DV1,DV2: ^DRec;
			RNum,FrD1,FrD2,HDReg,orn,FrA1,FrA2: Byte;
			Txt1,Txt2: String[20];
			dt: String[1];
			SNat,Nat1,Nat2,InD,Zn: Boolean;
			LI1,LI2: LongInt;

		Procedure PP;
		begin
			Put(Txt2);
			Put(',');
			PutL(Txt1);
		end;

		Procedure PutS;
		begin
			case TNum of
				stndByte,stndUByte: Put('.b');
				stndWord,stndUWord: Put('.w');
				stndLong,stndULong: Put('.l');
				end;
		end;

		Procedure Swap;
		begin
			case D of
				0,2,7,8,10,11,12,13,14,15,16,17: begin
					C3 := C1;
					C1 := C2;
					C2 := C3;
					end;
				end;
		end;

		Procedure PutNr;
		begin
			case TNr of
				stndByte,stndUByte: Put('.b'#9);
				stndWord,stndUWord: Put('.w'#9);
				stndLong,stndULong: Put('.l'#9);
				end;
		end;

		Procedure Pand;
		begin
			PutL(Txt1);
			Put(#9#9'and.l'#9'#1,');
			PutL(Txt1);
		end;

		Procedure Pcmp;
		begin
			Put(#9#9'cmp');
			PutNR;
			PP;
		end;

		begin
			Nat1 := False;
			Nat2 := False;
			NoChg := False;

			FrD1 := 255;
			FrD2 := 255;
			FrA1 := 255;
			FrA2 := 255;

			if (C1.ctTyp = ctConst) then begin
				LI1 := C1.ValNum;
				Nat1 := True;
				end;

			if (C2.ctTyp = ctConst) then begin
				LI2 := C2.ValNum;
				Nat2 := True;
				end;

			if Nat1 and Nat2 then begin
				Push;
				C^.ctTyp := ctConst;
				C^.ValNum := Let(LI1,LI2,D);
				SetS(C^.ValNum,C^);
				Exit;
				end;

			if (C1.ctTyp = ctConst) and (C2.ctTyp = ctDVar) then
				Swap;

			if (C1.ctTyp <> ctReg) and (C2.ctTyp = ctReg) then
				Swap;

			TNr := TNum;
			TNr1 := TypeToSize(C1.ctVTyp);
			TNr2 := TypeToSize(C2.ctVTyp);
			TNr3 := TypeToSize(TNum);

			if (D = 10) or (D = 11) or (D = 253) then
				NoChg := True
			else
				if (TNr1 > TNr3) or (TNr2 > TNr3) then begin
					TNr3 := TNr1;
					if (TNr2 > TNr1) then TNr3 := TNr2;
					case TNum of
						stndByte,stndWord,stndLong:
							case TNr3 of
								siByte: TNr := stndByte;
								siWord: TNr := stndWord;
								siLong: TNr := stndLong;
								end;
						stndUByte,stndUWord,stndULong:
							case TNr3 of
								siByte: TNr := stndUByte;
								siWord: TNr := stndUWord;
								siLong: TNr := stndULong;
								end;
						end;
					end;

			if (D = 3) or (D = 4) or (D = 2) then begin
				if (TNr = stndByte) then TNr := stndWord;
				if (TNr = stndUByte) then TNr := stndUWord;
				end;

		if (D <> 253) then begin
			if (C1.ctTyp = ctDVar) then begin
				DV1 := C1.DPtr;
				CompD(False,NoChg,C1.DPtr,TNr,FrD1,FrA1,Txt1,InD,HlpB);
				if (FrD1 <> 255) then begin
					RNum := FrD1;
					FrD1 := 255;
					end
				else
					RNum := AllocReg(True,TNr);
				Str(RNum,dt);
				if Not(InD) and Not(NoChg) then begin
					case TNr of
						stndByte,stndUByte:	Put(#9#9'move.b'#9);
						stndWord,stndUWord:	Put(#9#9'move.w'#9);
						stndLong,stndULong:	Put(#9#9'move.l'#9);
						end;
					Put(Txt1);
					Put(',d');
					PutL(dt);
					end;
				if Not(InD) and NoChg then begin
					case TNr1 of
						siByte: Put(#9#9'move.b'#9);
						siWord: Put(#9#9'move.w'#9);
						siLong: Put(#9#9'move.l'#9);
						end;
					Put(Txt1);
					Put(',d');
					PutL(dt);
					end;
				end
			else if (C1.ctTyp = ctReg) then begin
				RNum := C1.ValNum;
				Str(RNum,dt);
				end
			else if (C1.ctTyp = ctConst) then begin
				RNum := AllocReg(True,TNr);
				Str(RNum,dt);
				Str(C1.ValNum,HTxt);
				if (C1.ValNum >= -128) and (C1.ValNum <= 127) then
					Put(#9#9'moveq'#9'#')
				else
					case TNr of
						stndByte,stndUByte:	Put(#9#9'move.b'#9'#');
						stndWord,stndUWord:	Put(#9#9'move.w'#9'#');
						stndLong,stndULong:	Put(#9#9'move.l'#9'#');
						end;
				Put(HTxt);
				Put(',d');
				PutL(dt);
				end;
			end;

			Txt1 := 'd'+dt;
			SNat := False;

			if (C2.ctTyp = ctDVar) then begin
				DV2 := C2.DPtr;
				CompD(False,NoChg,C2.DPtr,TNr,FrD2,FrA2,Txt2,InD,HlpB);
				if InD then begin
					Str(FrD2,HTxt);
					Txt2 := 'd'+HTxt;
					end;
				end
			else if (C2.ctTyp = ctReg) then begin
				Str(C2.ValNum,HTxt);
				Txt2 := 'd'+HTxt;
				FrD2 := C2.ValNum;
				end
			else if (C2.ctTyp = ctConst) then begin
				Str(C2.ValNum,HTxt);
				Txt2 := '#'+HTxt;
				SNat := True;
				end;

			Zn := True;
			case TNr of
				stndUByte,stndUWord,stndULong: Zn := False;
				end;

			case D of
				253: begin
					if SNat then begin
						RNum := AllocReg(True,0);
						Str(RNum,dt);
						Txt1 := 'd'+dt;
						Put(#9#9'moveq'#9'#');
						if (C2.ValNum = 0) then
							Put('1')
						else
							Put('0');
						Put(',');
						PutL(Txt1);
						Goto Skip;
						end;
					if (C2.ctTyp = ctReg) or ((C2.ctTyp = ctDVar) and InD) then begin
						RNum := FrD2;
						FrD2 := 255;
						Put(#9#9'tst.');
						case TNr2 of
							siByte: Put('b');
							siWord: Put('w');
							siLong: Put('l');
							end;
						Put(#9);
						PutL(Txt2);
						Put(#9#9'seq'#9);
						PutL(Txt2);
						Put(#9#9'and.l'#9'#1,');
						PutL(Txt2);
						Goto Skip;
						end;
					if (FrD2 = 255) then
						RNum := AllocReg(True,0)
					else begin
						RNum := FrD2;
						FrD2 := 255;
						end;
					Put(#9#9'move.');
					case TNr2 of
						siByte: Put('b');
						siWord: Put('w');
						siLong: Put('l');
						end;
					Put(#9);
					Put(Txt2);
					Put(',d');
					Str(RNum,dt);
					PutL(dt);
					Txt2 := 'd'+dt;
					Put(#9#9'seq'#9);
					PutL(Txt2);
					Put(#9#9'and.l'#9'#1,');
					PutL(Txt2);
					end;
				0: begin
					Put(#9#9'add');
					PutNr;
					PP;
					end;
				1: begin
					Put(#9#9'sub');
					PutNr;
					PP;
					end;
				2: begin
					if Zn then
						Put(#9#9'mulu')
					else
						Put(#9#9'muls');
					PutNr;
					PP;
					end;
				3: begin
					if Zn then
						Put(#9#9'divu')
					else
						Put(#9#9'divs');
					PutNr;
					PP;
					end;
				4: begin
					if Zn then
						Put(#9#9'divu')
					else
						Put(#9#9'divs');
					PutNr;
					PP;
					Put(#9#9'swap'#9);
					PutL(Txt1);
					end;
				5,6: begin
					if (FrD2 <> 255) then begin
						case D of
							5: Put(#9#9'lsl');
							6: Put(#9#9'lsr');
							end;
						PutNr;
						PP;
						Goto Skip;
						end;
					if SNat then begin
						if (C2.ValNum < 1) or (C2.ValNum > 8) then Err(71);
						case D of
							5: Put(#9#9'lsl');
							6: Put(#9#9'lsr');
							end;
						PutNr;
						PP;
						Goto Skip;
						end;
					HDReg := AllocReg(True,stndWord);
					Put(#9#9'moveq'#9'#0,d');
					Str(HDReg,HTxt);
					PutL(HTxt);
					Put(#9#9'move');
					PutNR;
					Put(Txt2);
					Put(',d');
					PutL(HTxt);
					case D of
						5: Put(#9#9'lsl');
						6: Put(#9#9'lsr');
						end;
					PutNR;
					Put('d');
					Put(HTxt);
					Put(',');
					PutL(Txt1);
					FreeReg(True,HDReg);
					end;
				7: begin
					Put(#9#9'and');
					PutNr;
					PP;
					end;
				8: begin
					Put(#9#9'or');
					PutNr;
					PP;
					end;
				9: begin
					Err(72);
					{ Chwilowo nieczynna !! }
					Put(#9#9'eor');
					PutNr;
					PP;
					end;
				10: begin
					if SNat then begin
						if (C2.ValNum = 0) then
							Put(#9#9'moveq'#9'#0,')
						else
							Put(#9#9'moveq'#9'#1,');
						PutL(Txt1);
						Goto Skip;
						end;
					case TNr1 of
						siByte: Put(#9#9'tst.b'#9);
						siWord: Put(#9#9'tst.w'#9);
						siLong: Put(#9#9'tst.l'#9);
						end;
					PutL(Txt1);
					Put(#9#9'sne'#9);
					PutL(Txt1);
					if (TNr1 = siByte) and (TNr2 = siWord) then begin
						Put(#9#9'ext.w'#9);
						PutL(Txt1);
						end;
					if (TNr1 = siByte) and (TNr2 = siLong) then begin
						Put(#9#9'ext.w'#9);
						PutL(Txt1);
						Put(#9#9'ext.l'#9);
						PutL(Txt1);
						end;
					if (TNr1 = siWord) and (TNr2 = siLong) then begin
						Put(#9#9'ext.l'#9);
						PutL(Txt1);
						end;
					Put(#9#9'and.');
					case TNr2 of
						siByte: Put('b'#9);
						siWord: Put('w'#9);
						siLong: Put('l'#9);
						end;
					PP;
					Put(#9#9'sne'#9);
					Pand;
					end;
				11: begin
					if SNat and (C2.ValNum <> 0) then begin
						Put(#9#9'moveq'#9'#1,');
						PutL(Txt1);
						Goto Skip;
						end;
					if (TNr1 = siByte) and (TNr2 = siWord) then begin
						Put(#9#9'and.w'#9'#$ff,');
						PutL(Txt1);
						end;
					if (TNr1 = siByte) and (TNr2 = siLong) then begin
						Put(#9#9'and.l'#9'#$ff,');
						PutL(Txt1);
						end;
					if (TNr1 = siWord) and (TNr2 = siLong) then begin
						Put(#9#9'and.l'#9'#$ffff,');
						PutL(Txt1);
						end;
					Put(#9#9'or.');
					case TNr2 of
						siByte: Put('b'#9);
						siWord: Put('w'#9);
						siLong: Put('l'#9);
						end;
					PP;
					Put(#9#9'sne'#9);
					Pand;
					end;
				12: begin
					Pcmp;
					Put(#9#9'seq'#9);
					Pand;
					end;
				13: begin
					Pcmp;
					Put(#9#9'sne'#9);
					Pand;
					end;
				14: begin
					Pcmp;
					if Zn then
						Put(#9#9'sls'#9)
					else
						Put(#9#9'sle'#9);
					Pand;
					end;
				15: begin
					Pcmp;
					if Zn then
						Put(#9#9'scc'#9)
					else
						Put(#9#9'sge'#9);
					Pand;
					end;
				16: begin
					Pcmp;
					if Zn then
						Put(#9#9'shi'#9)
					else
						Put(#9#9'sgt'#9);
					Pand;
					end;
				17: begin
					Pcmp;
					if Zn then
						Put(#9#9'scs'#9)
					else
						Put(#9#9'slt'#9);
					Pand;
					end;
				end;
		Skip:
			Push;
			C^.ctTyp := ctReg;
			C^.ValNum := RNum;
			C^.ctVTyp := TNr;
			if (FrD1 <> 255) then FreeReg(True,FrD1);
			if (FrD2 <> 255) then FreeReg(True,FrD2);
			if (FrA1 <> 255) then FreeReg(False,FrA1);
			if (FrA2 <> 255) then FreeReg(False,FrA2);
		end;

	begin
		Stack := NIL;
		ONPVar := ptr;
	Loop:
		DVar := ONPVar^.Sklad;
		if (DVar^.typ = dtConst) then begin
			Push;
			C^.ctTyp := ctConst;
			C^.ValNum := DVar^.Value;
			SetS(DVar^.Value,C^);
			Goto Next;
			end;
		if (DVar^.typ = dtVarSize) then begin
			LI := GetVType(DVar);
			LI := TypeVar.MemSize;
			Push;
			C^.ctTyp := ctConst;
			C^.ValNum := LI;
			SetS(LI,C^);
			Goto Next;
			end;
		case DVar^.typ of
			dtVar,dtFunc,dtVarPtr,dtPFPtr: begin
				Push;
				C^.ctTyp := ctDVar;
				C^.DPtr := DVar;
				case DVar^.typ of
					dtVar: begin
						LI := GetVType(DVar);
						C^.ctVTyp := TypeVar.stndTyp;
						if (TypeVar.stndTyp = stndNew) and (TypeVar.defTyp = defPtr) then
							C^.ctVTyp := stndLong;
						if (C^.ctVTyp = stndNew) then Err(51);
						end;
					dtFunc: begin
						C^.ctVTyp := GetFType(DVar);
						if (C^.ctVTyp = stndNew) then Err(51);
						end;
					dtVarPtr,dtPFPtr: C^.ctVTyp := stndLong;
					end;
				Goto Next;
				end;
			end;
		if (DVar^.typ = dtDzial) then begin
			C := Stack;
			C2 := C^;
			Pop;
			C := Stack;
			C1 := C^;
			Pop;
			CompileDzial(DVar^.Dzial);
			Goto Next;
			end;
		Err(49);
	Next:
		ONPVar := ONPVar^.Next;
		if (ONPVar = NIL) then begin
			C := Stack;
			CV := C^;
			Pop;
			if (Stack <> NIL) then Err(49);
			Exit;
			end;
		Goto Loop;
	end;

	{ *** Otczymanie skompilowanej liczby danego typu. *** }
	Procedure CompInt(ptr: Pointer;  typ: Byte;  var Result: CompRec);
	var
		MyList: Pointer;
	begin
		ONP(ptr,MyList);
		if (MyList = NIL) then Err(63);
		CompONP(MyList,typ,Result);
		RemONP(MyList);
	end;

	{ *** Kompilacja przypisania. *** }
	Procedure CompLet(EndTxt: String; OKMList: Pointer;  OKSD: Byte);
	var
		Result: CompRec;
		Dtyp,Styp: Byte;
		Out1,Out2: String[20];
		UsedD1,UsedA1: Byte;
		UsedD2,UsedA2: Byte;
		InD1,InD2,HlpBB: Boolean;
		CopySize: LongInt;
		DVar: ^DRec;

		Procedure PutS;
		begin
			case Dtyp of
				stndByte,stndUByte: Put('b');
				stndWord,stndUWord: Put('w');
				stndLong,stndULong: Put('l');
			end;
		end;

		Procedure MoveToAn;
		begin
			UsedA1 := AllocReg(False,0);
			FreeReg(False,UsedA1);
			Str(UsedA1,HTxt);
			Put(#9#9'lea'#9);
			Put(Out1);
			Put(',a');
			PutL(HTxt);
			Out1 := '(a'+HTxt+')';
		end;

	begin
		if (OKMList = NIL) then
			if (EndTxt = ';') then
				MList := MakeMathList(gtZnak,False,';',True)
			else if (EndTxt = ')') then
				MList := MakeMathList(gtZnak,False,')',True)
			else
				MList := MakeMathList(gtIdent,False,EndTxt,True)
		else begin
			MList := OKMList;
			SpecDzial := OKSD;
			end;
		DecodeMath(MList,DList,Source);
		DVar := DList;
		if (DVar^.typ <> dtVar) then Err(48);
		Dtyp := GetVType(DVar);
		if (SpecDzial <> 0) and (Dtyp <> stndNew) then begin
			CopySize := 1;
			case SpecDzial of
				8,9: if (Source <> NIL) then Err(90);
				10,11: begin
					if (Source = NIL) then Err(91);
					DVar := Source;
					if (DVar^.typ <> dtConst) then Err(91);
					CopySize := DVar^.Value;
					end;
				end;
			CompD(False,True,DList,Dtyp,UsedD1,UsedA1,Out1,InD1,HlpB);
			if HlpB then MoveToAn;
			case SpecDzial of
				8,10: Put(#9#9'add.');
				9,11: Put(#9#9'sub.');
				end;
			PutS;
			Put(#9'#');
			Str(CopySize,HTxt);
			Put(HTxt);
			Put(',');
			PutL(Out1);
			if (UsedD1 <> 255) then FreeReg(True,UsedD1);
			if (UsedA1 <> 255) then FreeReg(False,UsedA1);
			RemMDList;
			Exit;
			end;
		if (Source = NIL) then Err(36);
		if (Dtyp <> stndNew) then begin
			UsedD1 := 255;
			UsedD2 := 255;
			UsedA1 := 255;
			UsedA2 := 255;
			CompInt(Source,Dtyp,Result);
			CompD(False,True,DList,Dtyp,UsedD1,UsedA1,Out1,InD1,HlpB);
			case Result.ctTyp of
				ctConst: begin
					if HlpB then MoveToAn;
					Put(#9#9'move.');
					case Dtyp of
						stndByte,stndUByte: Put('b'#9);
						stndWord,stndUWord: Put('w'#9);
						stndLong,stndULong: Put('l'#9);
						end;
					Put('#');
					Str(Result.ValNum,HTxt);
					Put(HTxt);
					Put(',');
					PutL(Out1);
					end;
				ctReg: begin
					if HlpB then MoveToAn;
					Put(#9#9'move.');
					case Dtyp of
						stndByte,stndUByte: Put('b'#9);
						stndWord,stndUWord: Put('w'#9);
						stndLong,stndULong: Put('l'#9);
						end;
					Put('d');
					UsedD2 := Result.ValNum;
					Str(UsedD2,HTxt);
					Put(HTxt);
					Put(',');
					PutL(Out1);
					end;
				ctDVar: begin
					HlpBB := HlpB;
					CompD(False,False,Result.DPtr,Dtyp,UsedD2,UsedA2,Out2,InD2,HlpB);
					if HlpBB then MoveToAn;
					Put(#9#9'move.');
					case Dtyp of
						stndByte,stndUByte: Put('b'#9);
						stndWord,stndUWord: Put('w'#9);
						stndLong,stndULong: Put('l'#9);
						end;
					Put(Out2);
					Put(',');
					PutL(Out1);
					end;
				end;
			if (UsedD1 <> 255) then
				FreeReg(True,UsedD1);
			if (UsedD2 <> 255) then
				FreeReg(True,UsedD2);
			if (UsedA1 <> 255) then
				FreeReg(False,UsedA1);
			if (UsedA2 <> 255) then
				FreeReg(False,UsedA2);
			end
		else begin
			STyp := GetVType(Source);
			CopySize := TypeVar.MemSize-1;
			if (Dtyp <> STyp) then Err(57);
			CompD(True,True,Source,0,UsedD1,UsedA1,Out1,InD1,HlpB);
			if (UsedD1 <> 255) then
				FreeReg(True,UsedD1);
			CompD(True,True,DList,0,UsedD2,UsedA2,Out2,InD2,HlpB);
			if (UsedD2 <> 255) then
				FreeReg(True,UsedD2);
			UsedD1 := AllocReg(True,stndWord);
			if (CopySize < 128) then
				Put(#9#9'moveq'#9'#')
			else
				Put(#9#9'move.w'#9'#');
			Str(CopySize,HTxt);
			Put(HTxt);
			Put(',d');
			Str(UsedD1,HTxt);
			PutL(HTxt);
			CopySize := JumpCnt;
			SetJump;
			Put(#9#9'move.b'#9'(a');
			Str(UsedA1,HTxt);
			Put(Htxt);
			Put(')+,(a');
			Str(UsedA2,HTxt);
			Put(Htxt);
			PutL(')+');
			Put(#9#9'dbf'#9'd');
			Str(UsedD1,HTxt);
			Put(Htxt);
			Put(',_');
				if UnitStat then begin
					Put(UnitFN);
					Put('_');
					end;
			Str(CopySize,HTxt);
			PutL(Htxt);
			FreeReg(True,UsedD1);

			if (UsedA1 <> 255) then
				FreeReg(False,UsedA1);
			if (UsedA2 <> 255) then
				FreeReg(False,UsedA2);
			end;
		RemMDList;
	end;

	{ *** Kompilacja wywolania. *** }
	Procedure CompCall(PFV: PrFuRec);
	var
		il,i: Byte;
	begin
		if (Depth = 1) and UnitStat then
			AddPFCall(PFV);
		il := PFV.IlP;
		if (il <> 0) then begin
			INr := Get;
			if (INr <> gtZnak) then Err(44);
			if (Ident <> '(') then Err(44);
			MList := MakeMathList(gtZnak,False,')',False);
			DecodeMath(MList,DList,Source);
			CompPFParam(DList,PFV.Name);
			RemMDList;
			end;
		HStr := PFV.Name;
		if (PFV.Dpth > 0) then begin
			PutL(#9#9'move.l'#9'a6,-(sp)');
			Str(PFV.Cntr,HTxt);
			if UnitStat then
				HStr := HStr+'_'+UnitFN+'_'+HTxt
			else
				HStr := HStr+'_'+HTxt;
			end;
		PutBSR(HStr);
		if (PFV.StackPar > 0) then begin
			Put(#9#9'lea'#9);
			Str(PFV.StackPar,HTxt);
			Put(HTxt);
			PutL('(sp),sp');
			end;
	end;

		Procedure CompExit;
		begin
			if (Depth = 0) then
				PutL(#9#9'rts')
			else begin
				PFPtr := PrFuList;
				PrFuVar := PFPtr^;
				PutL(#9#9'unlk'#9'a6');
				if (Depth > 1) then PutL(#9#9'move.l'#9'(a7)+,(a7)');
				PutL(#9#9'rts');
				end;
		end;


		Procedure CompIF(MPtr: Pointer;  var RetIF: Byte);
		var
			Result: CompRec;
			typ,UsedD,UsedA: Byte;
			Out: String[20];
			InD: Boolean;
		begin
			UsedD := 255;
			UsedA := 255;
			RetIF := IfUnknow;
			MList := MPtr;
			DecodeMath(MList,DList,Source);
			if (Source <> NIL) then Err(77);
			CompInt(DList,stndByte,Result);
			case Result.ctTyp of
				ctConst: begin
					if (Result.ValNum = 0) then
						RetIF := IfNever
					else
						RetIF := IfAlways;
					end;
				ctDVar: begin
					DVar := Result.DPtr;
					typ := stndLong;
					case DVar^.Typ of
						dtVar: typ := GetVType(Result.DPtr);
						dtFunc: begin
							MVar := DVar^.Start;
							if Not(GetPrFu(MVar^.Name,PrFuVar)) then Err(81);
							if Not(PrFuVar.FuStat) then Err(82);
							GetType(PrFuVar.FTName,True,TypeVar);
							typ := TypeVar.stndTyp;
							end;
						end;
					if (typ = stndNew) then Err(78);
					typ := TypeToSize(typ);
					CompD(False,True,Result.DPtr,0,UsedD,UsedA,Out,InD,HlpB);
					if InD then begin
						Put(#9#9'tst.');
						case typ of
							siByte: Put('b');
							siWord: Put('w');
							siLong: Put('l');
							end;
						Put(#9);
						PutL(Out);
						if (UsedD <> 255) then FreeReg(True,UsedD);
						if (UsedA <> 255) then FreeReg(False,UsedA);
						Exit;
						end;
					if HlpB then begin
						if (UsedA = 255) then
							UsedA := AllocReg(False,0);
						Put(#9#9'lea'#9);
						Put(Out);
						Put(',');
						Str(UsedA,HTxt);
						Out := '(a'+HTxt+')';
						PutL(Out);
						end;
					Put(#9#9'tst.');
					case typ of
						siByte: Put('b');
						siWord: Put('w');
						siLong: Put('l');
						end;
					Put(#9);
					PutL(Out);
					if (UsedD <> 255) then FreeReg(True,UsedD);
					if (UsedA <> 255) then FreeReg(False,UsedA);
					end;
				end;
			RemMDList;
		end;


{****************************************************************************}
						{ COMP BLOCK BEGIN }
{****************************************************************************}

begin
	if AsemStat then begin
		PutASM;
		Exit;
		end;
Loop:
	INr := Get;
	if (INr = gtEtyk) then begin
		Put(Ident);
		PutL(':');
		Goto Loop;
		end;
	if (INr <> gtIdent) then Err(9);
	INr := FindI;
CheckLET:
	if (INr = 0) then begin
		if GetPrFu(Ident,PFVar) then begin	{* CALL PROC *}
			if PFVar.FuStat then Err(30);
			CompCall(PFVar);
			Goto Next;
			end;
		CompLet(';',NIL,0);					{* LET *}
		if Retry then Goto Loop;
		Exit;
		end;
	if (INr = 3) then begin					{* BREAK *}
		INr := Get;
		if (INr <> gtZnak) and (INr <> gtValue) then Err(89);
		if (INr = gtZnak) and (Ident <> ';') then Err(89);
		if (INr = gtZnak) then begin
			SetBreak(1);
			Goto Next2;
			end;
		SetBreak(Value);
		Goto Next;
		end;
	if (INr = 27) then begin				{* CASE *}
		Jmp1 := AllocJump;
		MList := MakeMathList(gtIdent,False,'OF',False);
		DecodeMath(MList,DList,Source);
		DVar := DList;
		if (DVar^.Typ <> dtVar) and (DVar^.Typ <> dtFunc)
			then Err(85);
		case DVar^.Typ of
			dtVar: typ := GetVType(DList);
			dtFunc: begin
				MVar := DVar^.Start;
				if Not(GetPrFu(MVar^.Name,PrFuVar)) then Err(81);
				if Not(PrFuVar.FuStat) then Err(82);
				GetType(PrFuVar.FTName,True,TypeVar);
				typ := TypeVar.stndTyp;
				end;
			end;
		if (typ = stndNew) then Err(78);
		typ := TypeToSize(typ);
		CompInt(DList,stndByte,Result);
		UsedD := 255;
		UsedA := 255;
		case Result.ctTyp of
			ctReg: begin
				Str(Result.ValNum,HTxt);
				Out := 'd'+HTxt;
				UsedD := Result.ValNum;
				end;
			ctDVar: begin
				DVar := Result.DPtr;
				CompD(False,True,Result.DPtr,0,UsedD,UsedA,Out,InD,HlpB);
				if (UsedA <> 255) then FreeReg(False,UsedA);
				if HlpB then begin
					if (UsedD = 255) then
						UsedD := AllocReg(True,0);
					Put(#9#9'move.');
					case typ of
						siByte: Put('b');
						siWord: Put('w');
						siLong: Put('l');
						end;
					Put(#9);
					Put(Out);
					Put(',');
					Str(UsedD,HTxt);
					Out := 'd'+HTxt;
					PutL(Out);
					end;
				end;
			end;
		RemMDList;
		Jmp0 := AllocJump;
		SetCase := False;
	CaseLoop:
		INr := Get;
		if (INr = gtIdent) then begin
			INr := FindI;
			if (INr <> 42) then Err(86);
			if (UsedD <> 255) then FreeReg(True,UsedD);
			SetJump2(Jmp0);
			SetJump2(Jmp1);
			Goto Next;
			end;
		if SetCase then
			PutBRA2(Jmp1);
		SetJump2(Jmp0);
		Jmp0 := AllocJump;
		if (INr = gtValue) then begin
			Jmp2 := AllocJump;
		CaseNext:
			MList := MakeMathList(0,True,'',False);
			MemC := Ident[1];
			DecodeMath(MList,DList,Source);
			CompInt(DList,0,Result);
			if (Result.ctTyp <> ctConst) then Err(86);
			RemMDList;
			Put(#9#9'cmpi.');
			case typ of
				siByte: Put('b');
				siWord: Put('w');
				siLong: Put('l');
				end;
			Put(#9'#');
			Str(Result.ValNum,HTxt);
			Put(HTxt);
			Put(',');
			PutL(Out);
			if (MemC = ':') then begin
				PutBNE(Jmp0);
				SetJump2(Jmp2);
				CompBlock(False,False);
				SetCase := True;
				Goto CaseLoop;
				end
			else begin
				PutBEQ(Jmp2);
				INr := Get;
				if (INr <> gtValue) then Err(86);
				Goto CaseNext;
				end;
			end;
		Err(86);
		end;
	if (INr = 30) then begin				{* REPEAT *}
		Jmp2 := AllocJump;
		Jmp1 := AllocJump;
		SetJump2(Jmp2);
		AddBreak(Jmp1);
		CompBlock(False,False);
		RemBreak;
		INr := Get;
		if (INr <> gtIdent) then Err(83);
		INr := FindI;
		if (INr <> 31) then Err(83);
		MList := MakeMathList(gtZnak,False,';',False);
		CompIF(MList,RetIF);
		case RetIF of
			ifUnknow: PutBEQ(Jmp2);
			ifNever: PutBRA2(Jmp2);
			end;
		SetJump2(Jmp1);
		Goto Next2;
		end;
	if (INr = 29) then begin				{* WHILE *}
		Jmp2 := AllocJump;
		SetJump2(Jmp2);
		MList := MakeMathList(gtIdent,False,'DO',False);
		CompIF(MList,RetIF);
		Jmp1 := AllocJump;
		case RetIF of
			ifUnknow: PutBEQ(Jmp1);
			ifNever: PutBRA2(Jmp1);
			end;
		AddBreak(Jmp1);
		CompBlock(False,False);
		RemBreak;
		PutBRA2(Jmp2);
		SetJump2(Jmp1);
		Goto Next2;
		end;
	if (INr = 17) then begin				{* IFCASE *}
		Jmp2 := AllocJump;
	RetryIF:
		Jmp1 := AllocJump;
		MList := MakeMathList(gtIdent,False,'THEN',False);
		CompIF(MList,RetIF);
		case RetIF of
			ifUnknow: PutBEQ(Jmp1);
			ifNever: PutBRA2(Jmp1);
			end;
		CompBlock(False,False);
		INr := Get;
		if (INr <> gtIdent) then Err(9);
		INr := FindI;
		if (INr = 37) then begin			{* ELSE *}
			PutBRA2(Jmp2);
			SetJump2(Jmp1);
			CompBlock(False,False);
			SetJump2(Jmp2);
			Goto Next2;
			end;
		if (INr = 38) then begin			{* ELSEIF *}
			PutBRA2(Jmp2);
			SetJump2(Jmp1);
			Goto RetryIF;
			end;
		Err(80);
		end;
	if (INr = 35) then begin				{* IF *}
		MList := MakeMathList(gtIdent,False,'THEN',False);
		CompIF(MList,RetIF);
		Jmp1 := AllocJump;
		case RetIF of
			ifUnknow: PutBEQ(Jmp1);
			ifNever: PutBRA2(Jmp1);
			end;
		CompBlock(False,False);
		SetJump2(Jmp1);
		Goto Next2;
		end;
	if (INr = 23) then begin				{* FOR *}
		INr := Get;
		CompLet('TO',NIL,0);
		M1Mem := MakeMathList(gtIdent,False,'STEP',False);
		M2Mem := MakeMathList(gtIdent,False,'DO',False);
		SD2Mem := SpecDzial;
		Jmp1 := JumpCnt;
		SetJump;
		CompBlock(False,False);
		CompLet('',M2Mem,SD2Mem);
		CompIF(M1Mem,RetIF);
		case RetIF of
			IfUnknow: PutBEQ(Jmp1);
			IfNever: PutBRA2(Jmp1);
			end;
		Goto Next2;
		end;
	if (INr = 5) then begin					{* IFNZ *}
		INr := Get;
		CompLet('THEN',NIL,0);
		Jmp1 := AllocJump;
		PutBEQ(Jmp1);
		CompBlock(False,False);
		SetJump2(Jmp1);
		Goto Next2;
		end;
	if (INr = 6) then begin					{* IFZ *}
		INr := Get;
		CompLet('THEN',NIL,0);
		Jmp1 := AllocJump;
		PutBNE(Jmp1);
		CompBlock(False,False);
		SetJump2(Jmp1);
		Goto Next2;
		end;
	if (INr = 12) then begin				{* END *}
		Exit;
		end;
	if (INr = 16) then begin				{* ASM *}
		PutASM;
		Goto Next;
		end;
	if (INr = 39) then begin				{* GOTO *}
		MustIdent;
		PutBRA(Ident);
		Goto Next;
		end;
	if (INr = 11) then begin				{* BEGIN *}
		CompBlock(True,True);
		Goto Next;
		end;
	if (INr = 7) then begin					{* LOOP *}
		Jmp1 := AllocJump;
		Jmp2 := AllocJump;
		SetJump2(Jmp1);
		AddBreak(Jmp2);
		CompBlock(False,False);
		RemBreak;
		PutBRA2(Jmp1);
		SetJump2(Jmp2);
		Goto Next2;
		end;
	if (INr = 41) then begin				{* HALT *}
		if opLng then
			PutL(#9#9'move.l'#9'GlobalStack,a7')
		else
			PutL(#9#9'move.l'#9'GlobalStack(pc),a7');
		PutL(#9#9'rts');
		Goto Next;
		end;
	if (INr = 40) then begin				{* EXIT *}
		CompExit;
		Goto Next;
		end;
	Err(10);
Next:
	MustChar(';');
Next2:
	if Retry then Goto Loop;
	Exit;
end;

{ Dodanie do programu struktur z UNIT-u }

Procedure LinkGlobal;
label
	Loop;
var
	lvV: ^VarRec;
	lsV: ^StrRec;
	lcV: ^ConstRec;
	pfV: ^PrFuRec;
	pfV2: ^ParamRec;
	pfV3: ^UsedRec;
	ltV: ^TypeRec;
	ltV2: ^OneRec;

	i,j: Byte;

	MemUF: LongInt;

begin

	{ jesli jest robiony UNIT, to zapamietanie jego FileHandle }

	MemUF := UnitFile;

	UnitFile := Open(UnitDir+Ident,1005);
	if (UnitFile = 0) then Err(101);
Loop:
	UnitErr := Read_(UnitFile,@i,1);
	case i of
		0: begin
			Close_(UnitFile);
			UnitFile := MemUF;	{ zwrot FileHandle }
			Exit;
			end;
		1: begin
			lcV := New(ConstRecSize);
			UnitErr := Read_(UnitFile,@lcV^,ConstRecSize);
			lcV^.Next := ConstList;
			ConstList := lcV;
			Goto Loop;
			end;
		2: begin
			lsV := New(StrRecSize);
			UnitErr := Read_(UnitFile,@lsV^,StrRecSize);
			lsV^.Next := StrList;
			StrList := lsV;
			Goto Loop;
			end;
		3: begin
			pfV := New(PrFuRecSize);
			UnitErr := Read_(UnitFile,@pfV^,PrFuRecSize);
			pfV^.Next := PrFuList;
			PrFuList := pfV;
			pfV^.PFUsed := False;
			pfV^.PList := NIL;
			pfV^.UsedPFList := NIL;
			if (pfV^.IlP <> 0) then begin
				j := pfV^.IlP;
				for i := 1 to j do begin
					pfV2 := New(ParamRecSize);
					UnitErr := Read_(UnitFile,@pfV2^,ParamRecSize);
					pfV2^.Next := pfV^.PList;
					pfV^.PList := pfV2;
					end;
				end;
			if (pfV^.IlUsed <> 0) then begin
				j := pfV^.IlUsed;
				for i := 1 to j do begin
					pfV3 := New(UsedRecSize);
					UnitErr := Read_(UnitFile,@pfV3^,UsedRecSize);
					pfV3^.Next := pfV^.UsedPFList;
					pfV^.UsedPFList := pfV3;
					end;
				end;
			Goto Loop;
			end;
		4: begin
			lvV := New(VarRecSize);
			UnitErr := Read_(UnitFile,@lvV^,VarRecSize);
			lvV^.Next := VarList;
			VarList := lvV;
			Goto Loop;
			end;
		5: begin
			ltV := New(TypeRecSize);
			UnitErr := Read_(UnitFile,@ltV^,TypeRecSize);
			ltV^.Next := TypeList;
			TypeList := ltV;
			ltV^.RecList := NIL;
			if (ltV^.stndTyp = stndNew) and (ltV^.defTyp = defRec) then begin
				j := ltV^.Pola;
				for i := 1 to j do begin
					ltV2 := New(OneRecSize);
					UnitErr := Read_(UnitFile,@ltV2^,OneRecSize);
					ltV2^.Next := ltV^.RecList;
					ltV^.RecList := ltV2;
					end;
				end;
			Goto Loop;
			end;
		end;
	Err(103);
end;

{ Dodanie do listy uzytych modulow kolejnego modulu po USES }

Procedure AddUses;
label
	Loop,Retry;
var
	FN: String;
	S: LongInt;
	F: Text;
begin
	UsedVar := UsesUnitList;

	{ Petla odszukania, czy taki UNIT jest juz dolaczony }

Loop:
	if (UsedVar = NIL) then begin

		{ Unit nowo dolaczony }

		FN := UnitDir+Ident+'.Unit';
		S := FileS(FN);
		if (S = 0) then Err(99);
		Assign(F,FN);
		Reset(F);
Retry:
		ReadLn(F,FN);

		{ dolaczenie do tymczasowej listy nazw UNIT-ow uzytych w unicie }

		if (FN = 'UNIT') then begin
			ReadLn(F,FN);
			UsedVar := New(UsedRecSize);
			UsedVar^.Name := FN;
			UsedVar^.Next :=UFUList;
			UFUList := UsedVar;
			ReadLn(F,FN);
			Goto Retry;
			end;
		Close(F);

		{ dolaczenie tego nowego UNIT-u do listy glownej }

		UsedVar := New(UsedRecSize);
		UsedVar^.Name := Ident;
		UsedVar^.Next := UsesUnitList;
		UsesUnitList := UsedVar;

		{ Pobranie wszystkich struktur z nowego unitu i dolaczenie }

		LinkGlobal;
		Exit;
		end;
	if (UsedVar^.Name = Ident) then Exit;	{ unit juz jest }
	UsedVar := UsedVar^.Next;
	Goto Loop;
end;

{ Skopiowanie kodu asemblera uzytych PrFu z modulow do kodu wyjsciowego }

Procedure CopyUsesPrFu;
label
	Loop1,Loop2,Loop3;
var
	PrFuVar: ^PrFuRec;
	V: PrFuRec;
	Strt,Stp: LongInt;
	N: String;

	Procedure CopyPrFu;
	var
		F: File of Byte;
		B: Byte;
		Cnt,InBuf: LongInt;
		Buf: array [1..FileBuf] of Byte;
		ErrW: Word;
	begin
		Assign(F,UnitDir+N+'.s');
		Reset(F);
		Seek(F,Strt);
		InBuf := FileBuf+1;
		for Cnt := 1 to Stp-Strt do begin
			if (InBuf > FileBuf) then begin
				BlockRead(F,Buf,FileBuf);
				InBuf := 1;
				end;
			PutChar(Buf[InBuf]);
			Inc(InBuf);
			end;
		Close(F);
	end;

begin
	if (UsesUnitList = NIL) then Exit;
	PrFuVar := PrFuList;
Loop1:

	{ Sprawdzenie wszystkich obecnych PrFu. Jesli jakas jest z unitu
	i zostala uzyta, to zostaja ustawione na "uzyte" rowniez wszystkie
	PrFu jakie byly uzyte w tej PrFu }

	if (PrFuVar <> NIL) then begin
		if PrFuVar^.PFInUnit and PrFuVar^.PFUsed then begin
			UsedVar := PrFuVar^.UsedPFList;
Loop2:
			if (UsedVar <> NIL) then begin
				HlpB := GetPrFu(UsedVar^.Name,V);
				UsedVar := UsedVar^.Next;
				Goto Loop2;
				end;
			end;
		PrFuVar := PrFuVar^.Next;
		Goto Loop1;
		end;

	{ Jesli jest kompilacja unitu, to nie sa dolaczane do kodu wyjsciowego
	teksty zrodlowe uzytych PrFu }

	if UnitStat then Exit;

	{ Sprawdzenie wszystkich obecnych PrFu. Jesli PrFu jest z unitu i jest
	ustawiona na "uzyta", to jej tekst asemblera jest kopiowany na wyjscie }


	PrFuVar := PrFuList;
Loop3:
	if (PrFuVar <> NIL) then begin
		if PrFuVar^.PFInUnit and PrFuVar^.PFUsed then begin
			Strt := PrFuVar^.Start;
			Stp := PrFuVar^.Stop;
			N := PrFuVar^.UnitName;
			CopyPrFu;
			end;
		PrFuVar := PrFuVar^.Next;
		Goto Loop3;
		end;
end;

{ Jesli przy dolaczaniu UNIT-ow byly w nich uzyte inne UNIT-y, to ich spis
znajduje sie tymczasowej liscie UFUList. Teraz zostaja one dolaczone do
glownej listy spisu uzytych unitow. }

Procedure AddUnitFromUnit;
var
	V: ^UsedRec;
begin
	V := UFUList;
	while (V <> NIL) do begin
		Ident := V^.Name;
		AddUses;
		V := V^.Next;
		end;
end;

Procedure ClearPrFu;
begin
	PFPtr := PrFuList;
	while (PFPtr <> NIL) do begin
		PFPtr^.PFUsed := False;
		PFPtr := PFPtr^.Next;
		end;
end;

Procedure CopyToTemp;
var
	TN,SN,DN: String[80];
	V: ^UsedRec;

	Procedure FileCopy;
	label
		Loop;
	const
		BufSize = 10240;
	var
		Buf: array [1..BufSize] of Byte;
		sf,df,s,r: LongInt;
	begin
		s := FileS(SN);
		if (s = 0) then Exit;
		sf := Open(SN,1005);
		df := Open(DN,1006);
Loop:
		r := s;
		if (r > BufSize) then r := BufSize;
		UnitErr := Read_(sf,@Buf,r);
		UnitErr := Write_(df,@Buf,r);
		s := s-r;
		if (s > 0) then Goto Loop;
		Close_(sf);
		Close_(df);
	end;

begin
	V := UsesUnitList;
	while (V <> NIL) do begin
		SN := UnitDir+V^.Name+'.s';
		DN := txtTmp+V^.Name+'.s';
		FileCopy;
		V := V^.Next;
		end;
end;

{****************************************************************************}
								{ MAIN BEGIN }
{****************************************************************************}

begin
	CheckMem := False;
	UnitFile := 0;
	UnitStat := False;
	UnitFlush := False;
	opOpt := True;
	opLng := False;
	opClrD0 := True;
	opInst := False;
	Start;
	AsemStat := False;
	PutL('_BEGIN:');
MainLoop:
	MustIdent;
	INr := FindI;
MainLoop2:
	if (INr = 1) then begin
		UnitStat := True;
		MustChar(';');
		UnitFile := Open(UnitDir+UnitFN,1006);
		WriteLn('Create Unit: ',UnitFN);
		Goto MainLoop;
		end;
	if (INr = 2) then begin					{* USES *}
		if (Leek <> NIL) and Not(UnitStat) then begin
			WriteLn('Add from memory.');
			InstV1 := Leek;
			TypeList :=	InstV1^.TypePtr;
			PrFuList :=	InstV1^.PrFuPtr;
			ConstList := InstV1^.ConstPtr;
			VarList :=	InstV1^.VarPtr;
			StrList :=	InstV1^.StrPtr;
			UsesUnitList := InstV1^.UULPtr;
LoopSkip:
			INr := Get;
			if (INr <> gtZnak) then Goto LoopSkip;
			if (Ident <> ';') then Goto LoopSkip;
			CheckMem := True;
			ClearPrFu;
			UnitDir := txtTmp;
			Goto MainLoop;
			end;
LoopUses:
		MustIdent;
		AddUses;
		INr := Get;
		if (INr <> gtZnak) then Err(93);
		if (Ident = ';') then begin
			AddUnitFromUnit;
			if opInst then begin
				InstV1 := New(InstallRecSize);
				InstV1^.TypePtr := TypeList;
				InstV1^.PrFuPtr := PrFuList;
				InstV1^.ConstPtr := ConstList;
				InstV1^.VarPtr := VarList;
				InstV1^.StrPtr := StrList;
				InstV1^.UULPtr := UsesUnitList;
				Loke(InstV1);
				MemoryList := MMList;
				CopyToTemp;
				Stop(False);
				WriteLn('All in memory. Compile again.');
				Halt;
				end;
			Goto MainLoop;
			end;
		if (Ident <> ',') then Err(93);
		Goto LoopUses;
		end;
	if (INr = 12) and UnitStat then	begin	{* END *}
		MustChar('.');
		Goto CompileEnd;
		end;
	if (INr = 0) then Err(10);
	if (INr = 13) then begin		{* CONST *}
		CompConst;
		Goto MainLoop2;
		end;
	if (INr = 14) then begin		{* TYPE *}
		CompType;
		Goto MainLoop2;
		end;
	if (INr = 15) then begin		{* VAR *}
		CompVar(False);
		Goto MainLoop2;
		end;
									{* PROC,FUNC,FORWARD *}
	if (INr = 18) or (INr = 19) or (INr = 33) or (INr = 34) or (INr = 32) then begin
		AsemStat := False;
		if (INr = 33) then begin
			INr := 18;
			AsemStat := True;
			end;
		if (INr = 34) then begin
			INr := 19;
			AsemStat := True;
			end;
		NoFrwd := (INr <> 32);
		if Not(NoFrwd) then begin
			MustIdent;
            INr := FindI;
			end;
		MINr := INr;
		if (Get <> gtIdent) then Err(9);
		PFFrwd := GetPrFu(Ident,PrFuVar);
		if PFFrwd and (Depth = PrFuVar.Dpth) then begin

			{ dodanie zmiennych lokalnych i parametrow zapamietanych
			w MemVar do glownej listy zmiennych }

			if (PrFuVar.MemVar <> NIL) then begin
				VVar := PrFuVar.MemVar;
			FindVar:
				if (VVar^.Next <> NIL) then begin
					VVar := VVar^.Next;
					Goto FindVar;
					end;
				VVar^.Next := VarList;
				VarList := PrFuVar.MemVar;
				end;
			Inc(Depth);
			PFToFront(Ident);
			MustChar(';');
			Goto MainLoop;
			end;
		if FirstPF and NoFrwd and Not(UnitStat) then begin
			FirstPF := False;
			PutBRA('_MAIN');
			PutL('');
			end;
		if UnitStat then
			PrFuVar.UnitName := UnitFN;
		PrFuVar.AsmStat := AsemStat;
		PrFuVar.Name := Ident;
		PrFuVar.IlP := 0;
		PrFuVar.PList := NIL;
		PrFuVar.FuStat := (MInr = 19);
		Inc(PFCounter);
		PrFuVar.Cntr := PFCounter;
		PrFuVar.StackPtr := 0;
		PrFuVar.StackPar := 0;
		MustChar('(');
		Inc(Depth);
		if Not(NoFrwd) then begin
			MemVL := VarList;
			VarList := NIL;
			end;
		CompVar(True);
		EEven(PrFuVar.StackPar);
		Dec(Depth);
		if (Ident <> ')') then Err(28);
		if (MInr = 19) then begin
			MustChar(':');
			if (Get <> gtIdent) then Err(9);
			if not(AskType(Ident)) then Err(17);
			PrFuVar.FTName := Ident;
			GetType(Ident,False,TypeVar);
			VarVar.TName := Ident;
			VarVar.Name := 'RETURN';
			VarVar.VarOp := opSts;
			VarVar.AdrOfs := 8;
			VarVar.MSize := 4;
			VarVar.Even := 1;
			if (Depth >= 1) then begin
				Inc(VarVar.AdrOfs,4);
				Inc(PrFuVar.StackPar,4);
				end;
			Inc(Depth);
			AddVar(VarVar);
			Dec(Depth);
			Inc(PrFuVar.StackPar,4);
			EEven(PrFuVar.StackPar);
			end;
		MustChar(';');
		if Not(NoFrwd) then begin
			PrFuVar.MemVar := VarList;
			VarList := MemVL;
			end;
		AddPrFu(PrFuVar);
		Inc(Depth);
		if Not(NoFrwd) then Dec(Depth);
		Goto MainLoop;
		end;
	if (INr = 11) then				{* BEGIN *}
		if (Depth = 0) then begin
			ClrRegs;
			PutL('');
			PutL('_MAIN:');
			if opLng then
				PutL(#9#9'lea'#9'GlobalStack,a6')
			else
				PutL(#9#9'lea'#9'GlobalStack(pc),a6');
			PutL(#9#9'move.l'#9'a7,(a6)');
			CompBlock(True,True);
			MustChar('.');
			if opClrD0 then PutL(#9#9'moveq'#9'#0,d0');
			PutL(#9#9'rts');
			Goto CompileEnd;
			end
		else begin
			ClrRegs;
			PFPtr := PrFuList;
		PFLoop:
			if (PFPtr^.Dpth = Depth) then begin
				PFPtr := PFPtr^.Next;
				Goto PFLoop;
				end;
			MemPF := PFPtr;
			PFPtr^.Start := OutFileCnt;
			PrFuVar := PFPtr^;
			if (Depth = 1) then
				ActualPF := PFPtr;
			PutL('');
			Put(PrFuVar.Name);
			if (PFPtr^.Dpth > 1) then begin
				if UnitStat then begin
					Put('_');
					Put(UnitFN);
					end;
				Put('_');
				Str(PrFuVar.Cntr,HTxt);
				Put(HTxt);
				end;
			PutL(':');
			EEven(PrFuVar.StackPtr);
			AsemStat := PrFuVar.AsmStat;;
			if AsemStat then begin
				CompBlock(True,True);
				end
			else begin
				Put(#9#9'link'#9'a6,#');
				if (PrFuVar.StackPtr <> 0) then begin

					Put('-');
					Str(PrFuVar.StackPtr,Hlp);
					PutL(Hlp);
					end
				else
					PutL('0');
				CompBlock(True,True);
				PutL(#9#9'unlk'#9'a6');
				end;
			if (Depth > 1) then PutL(#9#9'move.l'#9'(a7)+,(a7)');
			PutL(#9#9'rts');
			RemType;
			PutL('');
			RemConst;
			RemVar;
			RemPrFu;
			Dec(Depth);
			MustChar(';');
			AsemStat := False;
			MemPF^.Stop := OutFileCnt;
			Goto MainLoop;
			end;
	if (INr = 4) then begin			{* OPTIONS *}
		INr := Get;
		if (INr <> gtValue) then Err(87);
		opOpt := False;
		opLng := False;
		opClrD0 := False;
		if BTst(0,Value) then opOpt := True;
		if BTst(1,Value) then opLng := True;
		if BTst(2,Value) then opClrD0 := True;
		MustChar(';');
		Goto MainLoop;
		end;
	if (INr = 16) then begin		{* ASM *}
		PutASM;
		MustChar(';');
		Goto MainLoop;
		end;
	if (INr = 43) then begin		{* LINKPF *}
LinkPFLoop:
		MustIdent;
		if Not(GetPrFu(Ident,PFVar)) then Err(100);
		AddPFCall(PFVar);
		INr := Get;
		if (INr <> gtZnak) then Err(93);
		if (Ident = ';') then Goto MainLoop;
		if (Ident <> ',') then Err(93);
		Goto LinkPFLoop;
		end;
	ErrT := Ident;
	Err(12);
CompileEnd:
	if (GetC = #0) then begin end;
	CopyUsesPrFu;
	PutL('');
	FlushToEOF;
	Stop(True);
	WriteLn('Done.');
end.
